# -*- coding:utf-8 -*-
import stat
import os
import tornado.web

import string
import tornado.gen
import tornado.ioloop
import tornado.httpserver
from tornado import iostream

from analy_python_mongo.AnalysisMongoDetail import *
from nacos_py import *

class NpEncoder(json.JSONEncoder):
    def default(self, obj):
        if isinstance(obj, np.integer):
            return int(obj)
        elif isinstance(obj, np.floating):
            return float(obj)
        elif isinstance(obj, np.ndarray):
            return obj.tolist()
        else:
            return super(NpEncoder, self).default(obj)

class IndexHandler(tornado.web.RequestHandler):
    def get(self):
        self.write("Hello, world")

class statafile_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested statafile")

    def post(self, *args, **kwargs):
        # if self.reuqest.headers.get("Content-Type", "").startswith("application/json"):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            print(type(receive_data))
            if isinstance(receive_data,str):
                print("str")
                receive_data=json.loads(receive_data)
                print(type(receive_data))
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            projectId=receive_data['projectId']
            dataSetId=receive_data['dataSetId']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            variableNames=receive_data['variableNames']
            scope=receive_data['scope']

            if receive_data.__contains__('selectedIds')==True:
                selectedIds=receive_data['selectedIds']
            else:
                selectedIds=None
            if receive_data.__contains__('sampleDataIds')==True:
                sampleDataIds=receive_data['sampleDataIds']
            else:
                sampleDataIds=None


            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            mongodb_cfg = nacos_py(serverUrl)[0]

            #
            result_data=statafile(dataSetId, projectId, variableNames, scope,selectedIds,sampleDataIds,dataVersion,mongodb_cfg,condition,varMissing)
            # result_data="stata_down/stata_down5ffed688c7995159f52abeab_60dd2b5ada396e74b2e8795f_1625212770.dta"
            # result_data = "stata_down/stata_down5ffed688c7995159f52abeab_60dd2b5ada396e74b2e8795f_1625209145.dta"

            self.write(result_data)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class stata_input_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the stata_input")

    def post(self, *args, **kwargs):
        try:
            if self.request.files:
                filename=self.request.files['filename'][0]
                timeStamp=int(time.time())
                oldfname=filename["filename"].rstrip(".dta")
                stata_input_file="statainput\\"+oldfname+"_"+str(timeStamp)+".dta"
                fin=open(stata_input_file, "wb")
                fin.write(filename["body"])
                fin.close()

            logging.info(self.request.arguments)
            receive_data=self.request.arguments
            print(type(receive_data))
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
                print(type(receive_data))
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            projectId=receive_data['paramsJson']['projectId']
            dataSetId=receive_data['paramsJson']['dataSetId']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            variableNames=receive_data['variableNames']
            scope=receive_data['scope']
            selectedIds=receive_data['selectedIds']
            if receive_data.__contains__('sampleDataIds')==True:
                sampleDataIds=receive_data['sampleDataIds']
            else:
                sampleDataIds=None

            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            mongodb_cfg=nacos_py(serverUrl)[0]

            #
            # result_data=stata_input(dataSetId, projectId, variableNames, scope,selectedIds,sampleDataIds,dataVersion,mongodb_cfg,condition,varMissing)
            resp=json.dumps("参数错误")
            self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class frequency_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the frequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data,str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']

            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)

            # 频次
            result_data = mongo_frequency_logic(dataSetId, VariableID, "", dataVersion, mongodb_cfg, redis_cfg,
                                                analyProcessId, condition,varMissing)
            if len(result_data['detailValid']) > maxResponseCount:
                del result_data['detailValid'][maxResponseCount:]
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class means_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the means")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            print(type(receive_data))
            if isinstance(receive_data,str):
                print("str")
                receive_data=json.loads(receive_data)
                print(type(receive_data))
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            IntervalRange = ''
            if 'IntervalRange' in receive_data['paramsJson']:
                IntervalRange = receive_data['paramsJson']['IntervalRange']
            replaceText = None
            if 'replaceText' in receive_data['paramsJson']:
                replaceText = receive_data['paramsJson']['replaceText']

            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
                print(condition)
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)

            # 均值
            result_data=mongo_means_logic(dataSetId, VariableID, IntervalRange, "", dataVersion, mongodb_cfg, redis_cfg,
                                          analyProcessId, condition,varMissing, replaceText)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class means2_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the means")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            print(type(receive_data))
            if isinstance(receive_data,str):
                print("str")
                receive_data=json.loads(receive_data)
                print(type(receive_data))
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None

            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
                print(condition)
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)

            # 均值
            result_data=mongo_means2_logic(dataSetId, VariableID, "", dataVersion, mongodb_cfg, redis_cfg,
                                           analyProcessId, condition)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class compareMeans_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the compareMeans")
    def post(self,*args,**kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data,str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            ColumnID=receive_data['paramsJson']['ColumnID']
            replaceText = None
            if 'replaceText' in receive_data['paramsJson']:
                replaceText = receive_data['paramsJson']['replaceText']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            #比较均值
            result_data=mongo_comparemeans_logic(dataSetId,VariableID,ColumnID, "", dataVersion, mongodb_cfg, redis_cfg,
                                                 analyProcessId, condition, varMissing, replaceText)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s" % str(e)+" "+str(self.request.remote_ip))
            resp = json.dumps({"code":"参数错误","msg":str(e)})
            print(resp)
            self.write(resp)

class compareMeans2_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the compareMeans")
    def post(self,*args,**kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data,str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            ColumnID=receive_data['paramsJson']['ColumnID']

            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None

            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            #比较均值
            result_data=mongo_comparemeans2_logic(dataSetId,VariableID,ColumnID, dataVersion, mongodb_cfg, redis_cfg,
                                                  analyProcessId, condition)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s" % str(e)+" "+str(self.request.remote_ip))
            resp = json.dumps({"code":"参数错误","msg":str(e)})
            print(resp)
            self.write(resp)

class multipleResponse_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multipleResponse")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            Separator = receive_data['paramsJson']['Separator']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 多重响应分析:单一变量
            result_data=mongo_multiple_logic(dataSetId, VariableID, Separator, dataVersion, mongodb_cfg, redis_cfg,
                                             analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class multiple2Response_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multiple2Response")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            counted_value=receive_data['paramsJson']['counted_value']
            OptionID=receive_data['paramsJson']['OptionID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 多重响应分析:二分法
            result_data=mongo_multiple2_logic(dataSetId, counted_value, OptionID, dataVersion, mongodb_cfg, redis_cfg,
                                              analyProcessId, condition,varMissing)
           
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp = json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class multipleTypeResponse_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multipleTypeResponse")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # VariableID=receive_data['paramsJson']['VariableID']
            OptionID=receive_data['paramsJson']['OptionID']
            StartValue = receive_data['paramsJson']['StartValue']
            if receive_data['paramsJson'].get('StartValue')==None:
                return "StartValue参数不能为空"
            EndValue = receive_data['paramsJson']['EndValue']
            if receive_data['paramsJson'].get('EndValue')==None:
                return "EndValue参数不能为空"

            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 多重响应分析: 类别方法
            result_data=mongo_multipleTypeResponse_logic(dataSetId, OptionID, StartValue, EndValue, dataVersion,
                                                         mongodb_cfg, redis_cfg, analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class crosstabs_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the crosstabs")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data = json.loads(self.request.body)
            if isinstance(receive_data, str):
                receive_data = json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据=' + json.dumps(receive_data, ensure_ascii=False))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID=receive_data['paramsJson']['RowID']
            ColumnID=receive_data['paramsJson']['ColumnID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 交叉表：列联表分析
            result_data=mongo_crosstabs_logic(dataSetId, RowID, ColumnID, "", dataVersion, mongodb_cfg, redis_cfg,
                                              analyProcessId, condition,varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class crosstabsMultipleResponse_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multipleResponse")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID = receive_data['paramsJson']['RowID']
            VariableID=receive_data['paramsJson']['VariableID']
            Separator = receive_data['paramsJson']['Separator']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 交叉表多重响应分析:单一变量
            result_data=mongo_crosstabsMultiple_logic(dataSetId, RowID, VariableID, Separator, dataVersion, mongodb_cfg,
                                                      redis_cfg, analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class crosstabsMultiple2Response_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multiple2Response")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data = json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data = json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据=' + str(receive_data))
            dataSetId = receive_data['paramsJson']['dataSetId']
            RowID = receive_data['paramsJson']['RowID']
            counted_value = receive_data['paramsJson']['counted_value']
            OptionID = receive_data['paramsJson']['OptionID']
            serverUrl = receive_data['serverUrl']
            if receive_data.get('dataVersion') != None:
                dataVersion = receive_data['dataVersion']
            else:
                dataVersion = None
            if receive_data.get('varMissing') != None:
                varMissing = receive_data['varMissing']
            else:
                varMissing = None
            if receive_data.get('condition') != None:
                condition = receive_data['condition']
            else:
                condition = None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 交叉表多重响应分析:二分法
            result_data = mongo_crosstabsMultiple2_logic(dataSetId, RowID, counted_value, OptionID, dataVersion,
                                                         mongodb_cfg, redis_cfg, analyProcessId, condition, varMissing)

            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s" % str(e) + " " + str(self.request.remote_ip))
            resp = json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class crosstabsMultipleTypeResponse_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multipleTypeResponse")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID = receive_data['paramsJson']['RowID']
            # VariableID=receive_data['paramsJson']['VariableID']
            OptionID=receive_data['paramsJson']['OptionID']
            StartValue = receive_data['paramsJson']['StartValue']
            if receive_data['paramsJson'].get('StartValue')==None:
                return "StartValue参数不能为空"
            EndValue = receive_data['paramsJson']['EndValue']
            if receive_data['paramsJson'].get('EndValue')==None:
                return "EndValue参数不能为空"

            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 交叉表多重响应分析: 类别方法
            result_data=mongo_crosstabsMultipleTypeResponse_logic(dataSetId, RowID, OptionID, StartValue, EndValue,
                                                                  dataVersion, mongodb_cfg, redis_cfg, analyProcessId,
                                                                  condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class multipleAndMultipleCrossResponse_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multiple2Response")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data = json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data = json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据=' + str(receive_data))
            dataSetId = receive_data['paramsJson']['dataSetId']
            OptionID_row = receive_data['paramsJson']['OptionID_row']
            counted_value_row = receive_data['paramsJson']['counted_value_row']
            OptionID_column = receive_data['paramsJson']['OptionID_column']
            counted_value_column = receive_data['paramsJson']['counted_value_column']
            serverUrl = receive_data['serverUrl']
            if receive_data.get('dataVersion') != None:
                dataVersion = receive_data['dataVersion']
            else:
                dataVersion = None
            if receive_data.get('varMissing') != None:
                varMissing = receive_data['varMissing']
            else:
                varMissing = None
            if receive_data.get('condition') != None:
                condition = receive_data['condition']
            else:
                condition = None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 交叉表多重响应分析:二分法
            result_data = mongo_multipleAndMultipleCross_logic(dataSetId, counted_value_row, OptionID_row,
                                                               counted_value_column, OptionID_column, dataVersion,
                                                         mongodb_cfg, redis_cfg, analyProcessId, condition, varMissing)

            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s" % str(e) + " " + str(self.request.remote_ip))
            resp = json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class multipleAndSingleCrossResponse_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the multiple2Response")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data = json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data = json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据=' + str(receive_data))
            dataSetId = receive_data['paramsJson']['dataSetId']
            OptionID_row = receive_data['paramsJson']['OptionID_row']
            counted_value_row = receive_data['paramsJson']['counted_value_row']
            ColumnID=receive_data['paramsJson']['ColumnID']
            serverUrl = receive_data['serverUrl']
            if receive_data.get('dataVersion') != None:
                dataVersion = receive_data['dataVersion']
            else:
                dataVersion = None
            if receive_data.get('varMissing') != None:
                varMissing = receive_data['varMissing']
            else:
                varMissing = None
            if receive_data.get('condition') != None:
                condition = receive_data['condition']
            else:
                condition = None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 交叉表多重响应分析:二分法
            result_data = mongo_multipleAndSingleCross_logic(dataSetId, counted_value_row, OptionID_row,
                                                             ColumnID, dataVersion, mongodb_cfg, redis_cfg,
                                                             analyProcessId, condition, varMissing)

            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s" % str(e) + " " + str(self.request.remote_ip))
            resp = json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class linearRegression_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the linearRegression")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID=receive_data['paramsJson']['RowID']
            ColumnID=receive_data['paramsJson']['ColumnID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 线性回归
            result_data=mongo_LinearRegressionDetail_logic(dataSetId, RowID, ColumnID,dataVersion, mongodb_cfg,
                                                           redis_cfg, analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)
#独立样本T检验
class Ttest_indResult_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the Ttest_indResult")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            print(type(self.request.body))
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID=receive_data['paramsJson']['RowID']
            ColumnID=receive_data['paramsJson']['ColumnID']
            specifiedValue1=receive_data['paramsJson']['specifiedValue1']
            specifiedValue2=receive_data['paramsJson']['specifiedValue2']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # T检验
            result_data=mongo_Ttest_indResultDetail_logic(dataSetId, RowID, ColumnID, specifiedValue1, specifiedValue2,
                                                          dataVersion, mongodb_cfg, redis_cfg, analyProcessId,
                                                          condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp = json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)
# 单样本T检验
class Ttest_SingleSample_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the Ttest_SingleSample")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            print(type(self.request.body))
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # T检验
            result_data=mongo_Ttest_SingleSample_logic(dataSetId, VariableID, dataVersion, mongodb_cfg, redis_cfg,
                                                       analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)
# 配对样本T检验
class Ttest_PairedSamples_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the Ttest_PairedSamples")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            print(type(self.request.body))
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID=receive_data['paramsJson']['RowID']
            ColumnID=receive_data['paramsJson']['ColumnID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 配对样本T检验
            result_data=mongo_Ttest_PairedSamples_logic(dataSetId, RowID, ColumnID, dataVersion, mongodb_cfg, redis_cfg,
                                                        analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class correlationAnalysis_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the correlationAnalysis")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            Corr=receive_data['paramsJson']['Corr']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 相关分析
            result_data=mongo_CorrelationAnalysis_logic(dataSetId, ColumnIDs, Corr, dataVersion, mongodb_cfg, redis_cfg,
                                                        analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class sort_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the sort")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID1=receive_data['paramsJson']['VariableID1']
            VariableID2=receive_data['paramsJson']['VariableID2']
            VariableID3=receive_data['paramsJson']['VariableID3']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 排序
            result_data=mongo_sort_logic(dataSetId, VariableID1, VariableID2, VariableID3, dataVersion, mongodb_cfg,
                                         redis_cfg, analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data,cls=NpEncoder)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class twoDimensionalLogisticRegression_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the twoDimensionalLogisticRegression")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            RowID=receive_data['paramsJson']['RowID']
            ColumnID=receive_data['paramsJson']['ColumnID']

            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
                pipeline_v = []
                pipeline_i= []
                for i in varMissing:
                    if varMissing[i]["type"]=="D":
                        if varMissing[i].get("D_Value1")!=None:
                            pipeline_v.append({ i:{"$ne": str(varMissing[i]["D_Value1"])}})
                        if varMissing[i].get("D_Value2")!=None:
                            pipeline_v.append({ i:{"$ne": str(varMissing[i]["D_Value2"])}})
                        if varMissing[i].get("D_Value3")!=None:
                            pipeline_v.append({ i:{"$ne": str(varMissing[i]["D_Value3"])}})
                    if varMissing[i]["type"]=="R":
                        if varMissing[i].get("S_Value")!=None:
                            pipeline_v.append({i: {"$ne": str(varMissing[i]["S_Value"])}})
                        if varMissing[i].get("L_Value1")!=None:
                            # pipeline_v2.append("this."+i+">"+str(varMissing[i]["L_Value1"]))
                            pipeline_v.append({i: {"$gte":  str(varMissing[i]["L_Value1"])}})
                        if varMissing[i].get("L_Value2")!=None:
                            # pipeline_v2.append("this."+i+"<"+str(varMissing[i]["L_Value2"]))
                            pipeline_v.append({i: {"$lte":  str(varMissing[i]["L_Value2"])}})
                    # pipeline_i.append({i:{"$convert":{"input":"$"+i,"to":"double", "onError": "问题："+"$"+i,"onNull":"missing i"}}})
                # pipeline = json.dumps(dict(zip(pipeline_k, pipeline_v)))
                # vM_pipeline=pipeline
                # pipeline = {"$match": {"$and": pipeline_v},"$where": {"$and": pipeline_v2}}
                # pipeline = {"$match": {"$and": pipeline_v},"$project":pipeline_i}
                pipeline = {"$match": {"$and": pipeline_v}}
                varMissing=dict(pipeline)
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)

            # 二元Logistics回归分析
            result_data=mongo_TwoDimensionalLogisticRegression_logic(dataSetId, RowID, ColumnID,dataVersion, mongodb_cfg,
                                                                     redis_cfg, analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)

class wordFrequency_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the wordFrequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            if receive_data['paramsJson'].get('removeWord') is not None:
                removeWord = receive_data['paramsJson']['removeWord']
            else:
                removeWord = None
            if receive_data['paramsJson'].get('addWord') is not None:
                addWord = receive_data['paramsJson']['addWord']
            else:
                addWord = None
            if receive_data.get('imageFlag') is not None and str(receive_data['imageFlag']) != '':
                imageFlag = True
            else:
                imageFlag = False
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 词频分析
            result_data=mongo_WordFrequency_logic(dataSetId, ColumnIDs, dataVersion, mongodb_cfg, redis_cfg,
                                                  analyProcessId, condition, removeWord, addWord, imageFlag, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)


class wordLDAModel_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the wordFrequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # LDA主题分析
            result_data = mongo_LDAModel_logic(dataSetId, ColumnIDs, dataVersion, mongodb_cfg, redis_cfg,
                                               analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)


class wordKmeansModel_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the wordFrequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # LDA主题分析
            result_data = mongo_kmeans_logic(dataSetId, ColumnIDs, dataVersion, mongodb_cfg, redis_cfg,
                                             analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)


class wordSentimentModel_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the wordFrequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # LDA主题分析
            result_data = mongo_sentiment_analysis_logic(dataSetId, ColumnIDs, dataVersion, mongodb_cfg, redis_cfg,
                                                         analyProcessId, condition,varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)


class wordSemanticNetworkModel_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the wordFrequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # LDA主题分析
            result_data = mongo_semantic_network_analysis_logic(dataSetId, ColumnIDs, dataVersion, mongodb_cfg,
                                                                redis_cfg, analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)


class wordSocialNetworkModel_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the wordFrequency")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            # RowID=receive_data['paramsJson']['RowID']
            ColumnIDs=receive_data['paramsJson']['ColumnIDs']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # LDA主题分析
            result_data = mongo_social_network_analysis_logic(dataSetId, ColumnIDs, dataVersion,mongodb_cfg, redis_cfg,
                                                              analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)


class normalityDistribution_Handler(tornado.web.RequestHandler):
    def get(self):
        self.write("You requested the normalityDistribution")

    def post(self, *args, **kwargs):
        try:
            logging.info(self.request.body)
            receive_data=json.loads(self.request.body)
            if isinstance(receive_data, str):
                print("str")
                receive_data=json.loads(receive_data)
            logging.info((type(receive_data), receive_data))

            print('接收到的json数据='+str(receive_data))
            dataSetId=receive_data['paramsJson']['dataSetId']
            VariableID=receive_data['paramsJson']['VariableID']
            serverUrl=receive_data['serverUrl']
            if receive_data.get('dataVersion')!=None:
                dataVersion=receive_data['dataVersion']
            else:
                dataVersion=None
            if receive_data.get('varMissing')!=None:
                varMissing=receive_data['varMissing']
            else:
                varMissing=None
            if receive_data.get('condition')!=None:
                condition=receive_data['condition']
            else:
                condition=None
            if condition:
                if isinstance(condition, str):
                    condition = json.loads(condition)
            if receive_data.get('analyProcessId') is not None:
                analyProcessId = receive_data['analyProcessId']
            else:
                analyProcessId = None
            mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
            # 正态分布
            result_data = mongo_NormalityDistribution_logic(dataSetId, VariableID, dataVersion, mongodb_cfg, redis_cfg,
                                                            analyProcessId, condition, varMissing)
            if analyProcessId is None:
                resp = json.dumps(result_data)
                self.write(resp)
        except Exception as e:
            logging.error("%s"%str(e)+" "+str(self.request.remote_ip))
            resp=json.dumps({"code": "参数错误", "msg": str(e)})
            print(resp)
            self.write(resp)
