#!/usr/bin/env python
# -*- coding:utf-8 -*-
from typing import Dict, List, Any

import chardet
import numpy as np
from bson import ObjectId
from pandas import DataFrame, Series
import pandas as pd
from statsmodels.formula.api import ols
import statsmodels.formula.api as smf
import statsmodels.api as sm
# from scipy.stats import chisquare
from collections import ChainMap

from analy_python_mongo.AnalysisMongoModel import *
from common.util.my_4_quartiles import my_4_quartiles, myNQuartiles
from patsy.highlevel import dmatrices
import math
from scipy.stats import pearsonr, kendalltau, spearmanr
import collections  # 词频统计库
import jieba  # 结巴分词
# import paddle
from scipy import stats
from scipy import *
from statsmodels.stats.diagnostic import lilliefors
from pandas.io.stata import StataReader, StataWriter
# from gensim import corpora
# from gensim.models.ldamodel import LdaModel
from nacos_py import *
# from sklearn.feature_extraction.text import TfidfVectorizer
# from sklearn.cluster import KMeans
# from transformers import pipeline
# import stanfordnlp
# import networkx as nx
import nltk
from nltk.corpus import stopwords
import redis
from redis.sentinel import Sentinel
from wordcloud import WordCloud, ImageColorGenerator
from PIL import Image


def statafile(dataSetId, projectId, variableNames, scope, selectedIds, sampleDataIds, dataVersion, mongodb_cfg,
              CasesCondition, userId):
    # retFrequency = mongoFrequencyModel(mongodb_cfg)
    # DataCount = retFrequency.CountMongo(dataSetId, dataVersion, VariableID, CasesCondition)
    res = Pymongoengine(mongodb_cfg)
    res.connect_db()

    pipeline = []
    variableNames_pipe, statafile_folder = '', ''
    selectedIds_pipe = []
    sampleDataIds_pipe = []
    for i in variableNames:
        variableNames_pipe += '\"' + i + '\":1,'
    variableNames_pipe = variableNames_pipe.rstrip(',')
    variableNames_pipe = '{\"_id\":0,' + variableNames_pipe + '}'
    variableNames_dict = json.loads(variableNames_pipe, encoding="utf-8")
    if CasesCondition is None:
        if scope == 'ALL':
            pipeline = [{"$match": {"projectId": projectId, }},
                        {"$project": variableNames_dict},
                        # {"$sort":{"datetime":-1}}
                        ]

        elif scope == 'SELECTED':
            for i_select in selectedIds:
                selectedIds_pipe.append(ObjectId(i_select))
            pipeline = [{"$match": {"dataSetId": dataSetId, "projectId": projectId, }},
                        {"$match": {"_id": {"$in": selectedIds_pipe, }}},
                        {"$project": variableNames_dict},
                        # {"$group": {"_id": "$_id", "count": {"$sum": 1}}},
                        ]

        elif scope == 'SAMPLE':
            for i_sample in sampleDataIds:
                sampleDataIds_pipe.append(ObjectId(i_sample))
            pipeline = [{"$match": {"dataSetId": dataSetId, "projectId": projectId, }},
                        {"$match": {"_id": {"$in": sampleDataIds_pipe, }}},
                        {"$project": variableNames_dict},
                        ]

    else:
        if scope == 'ALL':
            pipeline = [{"$match": {"dataSetId": dataSetId, "projectId": projectId, }},
                        {"$match": json.loads(CasesCondition)},
                        {"$project": variableNames_dict}, ]

        elif scope == 'SELECTED':
            for i_select in selectedIds:
                selectedIds_pipe.append(ObjectId(i_select))
            pipeline = [{"$match": {"dataSetId": dataSetId, "projectId": projectId, }},
                        {"$match": json.loads(CasesCondition)},
                        {"$match": {"_id": {"$in": selectedIds_pipe, }}}, {"$project": variableNames_dict}, ]

        elif scope == 'SAMPLE':
            for i_sample in sampleDataIds:
                sampleDataIds_pipe.append(ObjectId(i_sample))
            pipeline = [{"$match": {"dataSetId": dataSetId, "projectId": projectId, }},
                        {"$match": json.loads(CasesCondition)},
                        {"$match": {"_id": {"$in": sampleDataIds_pipe, }}}, {"$project": variableNames_dict}, ]
    key_dict1 = {}
    key_dict2 = {}
    key_dict3 = {}
    variable_count = len(variableNames)
    limit_count = 5000
    q_count = 0
    # if variable_count>500:
    #     limit_count=500
    # elif variable_count>300:
    #     limit_count = 1000

    key_dict1["$group"] = {"_id": "$_id", "count": {"$sum": 1}}
    # key_dict2["$skip"]= 0
    # key_dict3["$limit"]=limit_count
    pipeline.append(key_dict1)
    # pipeline.append(key_dict2)
    # pipeline.append(key_dict3)

    # if dataVersion and dataVersion is not None:
    #     ret_count = data_case.objects(dataSetId=dataSetId, dataVersion=dataVersion).aggregate(*pipeline)
    # else:
    ret_count = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
    for dataItem in ret_count:
        q_count = dataItem["count"]
    res.connect().close()
    pipeline.remove(key_dict1)
    timeStamp = int(time.time())
    isExists = os.path.exists("stata_down")
    if not isExists:
        os.makedirs("stata_down")

    # for i in range(0,q_count,limit_count):
    for i in range(0, 12):
        res.connect_db()
        key_dict2["$skip"] = limit_count * i
        key_dict3["$limit"] = limit_count
        pipeline.append(key_dict2)
        pipeline.append(key_dict3)
        # if dataVersion and dataVersion is not None:
        #     ret_data = data_case.objects(dataSetId=dataSetId, dataVersion=dataVersion).aggregate(*pipeline)
        # else:
        ret_data = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)

        pipeline.remove(key_dict2)
        pipeline.remove(key_dict3)

        res.connect().close()

        DataSource = []
        # print(chardet.detect(ret_data))
        for dataItem in ret_data:
            dataItem = json.dumps(dataItem, ensure_ascii=False)
            dataItem = dataItem.encode('utf-8')
            # print(chardet.detect(dataItem))
            dataItem = dataItem.decode('latin-1')
            # print(chardet.detect(dataItem.encode()))
            dataItem = json.loads(dataItem, encoding="latin-1")
            DataSource.append(dataItem)
        df = pd.DataFrame(DataSource)
        # print(df)

        statafile_folder = "stata_down/" + userId + "_" + dataSetId + "_" + str(timeStamp)
        statafile_childname = statafile_folder + "/" + str(i) + ".dta"
        isExists = os.path.exists(statafile_folder)
        if not isExists:
            os.makedirs(statafile_folder)

        # writer=StataWriter(fname="stata_down\\"+statafile_url, data=df,version=117)# variable_labels=variableNames
        # writer.write_file()
        df.to_stata(statafile_childname, version=117, write_index=False)
        # statafile_url="stata_down/?filename=stata_down/"+statafile_url

    statafile_name = str(timeStamp) + ".dta"
    # stata_childfile = os.listdir(statafile_folder)
    stata_files = []
    for stata_childfile in os.listdir(statafile_folder):
        path_file = os.path.join(statafile_folder, stata_childfile)
        stata_files.append(path_file)
    # os.chdir(statafile_folder)
    statafile_url = statafile_folder + "/" + statafile_name
    pd.concat([pd.read_stata(f) for f in stata_files]).to_stata(statafile_url, version=117, write_index=False)
    print("合并结束")

    return statafile_url


# def mongo_template_logic(PlatID, ProjID, TempID):
#     retTemp = mongoTemplateModel()
#     DataTemplate = retTemp.SelectTemplate(PlatID, ProjID, TempID)
#     return DataTemplate


def mongo_condition_logic(dataSetId, VariableID, versionNum, mongodb_cfg, CasesCondition):
    retFrequency = mongoFrequencyModel(mongodb_cfg)
    DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, None)
    return DataCount


# -----<频次分析>----- #
def mongo_frequency_logic(dataSetId, VariableID, phrase, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                          CasesCondition, varMissing):
    jsonValue = dict(head=[], detailValid=[], detailInvalid=[])  # type: Dict[Any, List[Any]]
    try:
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
        # retFrequency.close()
        varLabel = ""
        totalN, validN, invalidN = 0, 0, 0  # type: float
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # head计算
        validP, invalidP, missingP, DataSource, index = 0.0, 0.0, 0.0, [], 0
        # print(len(DataCount))
        for dataItem in DataCount:
            DataSource.append(dataItem)
        # df=pd.DataFrame(DataSource)
        # print(df)
        # timeStamp= int (time.time())
        # statafile_url="frequency_"+userId+"_"+dataSetId+"_"+str(timeStamp)+".dta"    #dataSetId+"_"
        # df.to_stata("statafile\\"+statafile_url)
        # statafile_url="statafile/?filename=statafile/"+statafile_url
        # DataSource
        if True:  # not variableVarValues or str(variableVarValues).strip() == "" or not check_json_format(str(variableVarValues)):
            for j in DataSource:
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                totalN += float(j['count'])
                if j['_id'] is not None and str(j['_id']).strip() != '' and str(j['_id']).strip() != '#NULL!':
                    validN += float(j['count'])
            for j in DataSource:
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                if j['_id'] is not None and str(j['_id']).strip() != '' and str(j['_id']).strip() != '#NULL!':
                    num, per, perV = float(j['count']), 0.0, 0.0
                    index += 1
                    if validN != 0:
                        perV = float(j['count']) / float(validN)
                    if totalN != 0:
                        per = float(j['count']) / float(totalN)
                    jsonValue["detailValid"].append(
                        dict(value=index, text=str(j['_id']).strip(), count=int(num), validpercent=perV, percent=per))
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            if float(totalN) != 0:
                if phrase != "":
                    varLabel = phrase
                validP = float(validN) / float(totalN)
                missingP = float(totalN - validN) / float(totalN)
                jsonValue["detailValid"].sort(key=lambda x: x["validpercent"], reverse=True)
            jsonValue["head"].append(
                dict(varLabel=varLabel, variableID=VariableID, count=int(validN), countD=len(jsonValue["detailValid"]),
                     totalN=int(totalN), validN=int(validN),
                     validP=validP, missingN=int(totalN - validN), missingP=missingP, analysis="frequency"))
            # jsonValue["statafile_url"]=statafile_url
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 均值
def mongo_means_logic(dataSetId, VariableID, IntervalRange, phrase, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                      CasesCondition, varMissing, replaceText):
    varLabel = ""
    jsonValue = dict(head=[], detailValid=[])
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        variableMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, VariableID)
        retMeans = mongoMeansModel(mongodb_cfg)
        DataSum = retMeans.SumMongo(dataSetId, versionNum, VariableID, CasesCondition, [], [])
        # retMeans.close()
        DataSort, replaceFrom, replaceTo, variableVarMissing, varMissingValue, varMissingValueRange = \
            [], [], [], None, [], []
        for variableItem in variableMeta:
            if 'varMissing' in variableItem:
                variableVarMissing = json.loads(variableItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        varMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        varMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    varMissingValue.append(str(variableVarMissing['S_Value']))
        DataList = pd.DataFrame(DataSum).values.tolist()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return

        if replaceText is None:
            replaceText = []
        for i in range(len(replaceText)):
            replaceFrom.append(replaceText[i][0])
            replaceTo.append(replaceText[i][1])

        # replaceText = []
        if isinstance(DataList, list) and len(DataList) > 0:
            # DataSort = [x for [x] in DataList]
            # replace "replaceTo" with "replaceFrom" [1,2,3]   DataList[i] 2

            for i in range(len(DataList)):
                DataList_i = DataList[i][0]
                if DataList_i in replaceFrom:
                    replaceIndex = replaceFrom.index(DataList_i)
                    DataList_i = replaceTo[replaceIndex]
                    # for replaceIndex, replaceItem in enumerate(replaceFrom):
                    #     if DataList[i] == replaceItem:
                    #         DataList[i] = replaceTo[replaceIndex]
                # DataSort.append(DataList[i][0])
                if DataList_i != '' and is_number(DataList_i) and DataList_i not in varMissingValue and \
                        not (len(varMissingValueRange) > 1 and
                             float(varMissingValueRange[0]) <= float(DataList_i) <= float(varMissingValueRange[1])):
                    DataSort.append(float(DataList_i))
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            # DataSort = [x for x in DataSort if x != '' and is_number(x)]
            # DataSort = [float(x) for x in DataSort]

        if isinstance(IntervalRange, list):
            DataSortCopy = DataSort[:]
            for num in DataSort:
                if num < float(IntervalRange[0]) or num > float(
                        IntervalRange[1]):  # float(IntervalRange[0]) > float(IntervalRange[1]):
                    DataSortCopy.remove(num)
            DataSort = DataSortCopy
        sumData, cnt, avg, maxData, mid, minData, mode, std, var = 0, 0, 0, 0, 0, 0, 0, 0, 0
        # print(DataSort)
        if len(DataSort) > 0:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            std = np.std(DataSort, axis=0, ddof=1)            # 数据只有1条会报错，除0错误，返回值nan
            maxData = np.max(DataSort)
            cnt = len(DataSort)
            sumData = np.sum(DataSort)
            minData = np.min(DataSort)
            avg = np.average(DataSort)
            # var = np.var(DataSort)
            var = float(np.cov(DataSort))
            mid = np.median(DataSort)
            gm = pd.Series(data=DataSort)
            mode = gm.mode()[0]
            if str(avg) == 'nan':
                std = gm.std()
                avg = gm.mean()
                sumData = gm.sum()
                cnt = int(gm.count())
                maxData = gm.max()
                minData = gm.min()
                var = gm.var()
                mid = gm.median()
            if phrase != "":
                varLabel = phrase

        jsonValue["head"].append(
            dict(varLabel=varLabel, variableID=VariableID, sum=sumData, count=cnt, average=avg,
                 max=maxData, median=mid, min=minData, mode=mode, stdev=nanToStr(std), variance=nanToStr(var),
                 Percent5=myNQuartiles(DataSort, 5), Percent25=myNQuartiles(DataSort, 25),
                 Percent75=myNQuartiles(DataSort, 75), Percent95=myNQuartiles(DataSort, 95), analysis="means"))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 均值简单快速查询
def mongo_means2_logic(dataSetId, VariableID, phrase, versionNum, mongodb_cfg, redis_cfg, analyProcessId,CasesCondition):
    varLabel = ""
    jsonValue = dict(head=[], detailValid=[])
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        variableMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, VariableID)

        DataSort, replaceFrom, replaceTo, variableVarMissing, varMissingDValue, varMissingValueRange = \
            [], [], [], None, [], []
        varMissingKey, varMissingValue = [], []
        for variableItem in variableMeta:
            if 'varMissing' in variableItem:
                variableVarMissing = json.loads(variableItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        varMissingDValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        varMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    varMissingDValue.append(str(variableVarMissing['S_Value']))
                if len(varMissingDValue) > 0:
                    varMissingKey.append(VariableID)
                    varMissingValue.append({'$nin': varMissingDValue})
                if len(varMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[VariableID] = {'$not': {'$gte': float(varMissingValueRange[0]),
                                                                '$lte': float(varMissingValueRange[1])}}
                    else:
                        CasesCondition = {VariableID: {'$not': {'$gte': float(varMissingValueRange[0]),
                                                                '$lte': float(varMissingValueRange[1])}}}
        retMeans = mongoMeansModel(mongodb_cfg)
        DataSum = retMeans.SumMongoAvg(dataSetId, versionNum, VariableID, CasesCondition, varMissingKey, varMissingValue)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        sumData, cnt, avg, maxData, mid, minData, mode, std, var = 0, 0, 0, 0, 0, 0, 0, 0, 0
        for dataItem in DataSum:
            if dataItem[VariableID + 'avg'] is not None and \
                    str(dataItem[VariableID + 'avg']).strip() != '':
                avg = float(str(dataItem[VariableID + 'avg']).strip())
                sumData = float(str(dataItem[VariableID + 'sum']).strip())
                maxData = float(str(dataItem[VariableID + 'max']).strip())
                minData = float(str(dataItem[VariableID + 'min']).strip())
                if dataItem['count'] is not None and str(dataItem['count']).strip() != '':
                    cnt = float(str(dataItem['count']).strip())
        if phrase != "":
            varLabel = phrase
        jsonValue["head"].append(dict(varLabel=varLabel, variableID=VariableID, sum=sumData, count=cnt, average=avg,
                                      max=maxData, min=minData, analysis="means"))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 多重响应分析:单一变量,,计数值：0 代表选中，1 代表未选中;  Separator='1',分隔符是；Separator='0',分隔符是.
def mongo_multiple_logic(dataSetId, VariableID, Separator, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                         CasesCondition, varMissing):
    jsonValue = dict(head=[], detailValid=[], detailInvalid=[])
    try:
        variableVarMissing, varMissingValue, varMissingValueRange = None, [], []
        retMeta = select_meta_variable(mongodb_cfg)
        variableMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, VariableID)
        for variableItem in variableMeta:
            if 'varMissing' in variableItem:
                variableVarMissing = json.loads(variableItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        varMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        varMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    varMissingValue.append(str(variableVarMissing['S_Value']))
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
        # retFrequency.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        if True:  # not variableVarValues or str(variableVarValues).strip()  == "" or not check_json_format(str(variableVarValues)):
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            DataCountVar = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
            # retFrequency.close()
            keys, values, index = [], [], 0
            for j in DataCountVar:
                if j['_id'] is not None and str(j['_id']).strip() != "":
                    if Separator == '1' and "," in j['_id']:
                        varstr = str(j['_id']).strip().split(",")
                    elif Separator == '0' and "." in j['_id']:
                        varstr = str(j['_id']).strip().split(".")
                    else:
                        varstr = [str(j['_id']).strip()]
                    for itemVar in varstr:
                        if itemVar not in values and itemVar not in varMissingValue and \
                            not (len(varMissingValueRange) > 1 and is_number(itemVar) and
                                 float(varMissingValueRange[0]) <= float(itemVar) <= float(varMissingValueRange[1])):
                            if is_number(itemVar):
                                index = int(itemVar)
                            else:
                                index += 1
                            keys.append(str(index))
                            values.append(itemVar)
            variableVarValues = json.dumps(dict(zip(keys, values)))
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        caseN, validN, missingN, invalidN, valueCount, missingCount, delimiter = 0.0, 0.0, 0.0, 0.0, {}, {}, "."
        for key, value in json.loads(variableVarValues).items():
            valueCount[key] = 0
        # if variableVarMissing==None:
        #     for key, value in json.loads(variableVarMissing).items():
        #         missingCount[key] = 0
        for j in DataCount:
            if j['_id'] is not None:
                if "," in j['_id']:
                    delimiter = ","
                check_id = delimiter + str(j['_id']).strip() + delimiter
                if len(varMissingValue) > 0:
                    for varMissingValueItem in varMissingValue:
                        check_id = check_id.replace(delimiter + varMissingValueItem + delimiter, delimiter)
                    if check_id == delimiter or check_id == delimiter + delimiter or \
                            check_id == delimiter + delimiter + delimiter:
                        check_id = ''
                if not j['_id'] or str(j['_id']).strip() == "" or str(j['_id']).strip() == "#NULL!" or check_id == '':
                    invalidN += float(j["count"])
                else:
                    for key, value in json.loads(variableVarValues).items():
                        if (delimiter + str(j['_id']) + delimiter).find(delimiter + str(key) + delimiter) >= 0:
                            for k, v in valueCount.items():
                                if key == k:
                                    valueCount[k] = v + float(j["count"])
                                    validN += float(j["count"])
                    # if variableVarMissing:
                    #     for key,value in json.loads(variableVarMissing).items():
                    #         if (delimiter + str(j['_id']) + delimiter).find(delimiter + str(key) + delimiter) >= 0:
                    #             for k, v in missingCount.items():
                    #                 if key == k:
                    #                     missingCount[k] = v + float(j["count"])
                    #                     invalidN += float(j["count"])
                    caseN += float(j["count"])
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        caseP, validP = 0.0, 0.0
        if caseN != 0: caseP = float(validN) / float(caseN)
        if validN != 0: validP = float(validN) / float(validN)
        jsonValue["head"].append(
            dict(varLabel_new='多重响应分析:单一变量', variableID=VariableID, count=int(validN), caseN=int(caseN), validN=int(validN),
                 invalidN=int(invalidN), casepercent=caseP, percent=validP, analysis="multiple"))
        for key, value in json.loads(variableVarValues).items():
            for k, v in valueCount.items():
                if str(key) == str(k):
                    num, caseP, validP = float(v), 0.0, 0.0
                    if caseN != 0:
                        caseP = float(v) / caseN
                    if validN != 0:
                        validP = float(v) / validN
                    jsonValue["detailValid"].append(
                        dict(value=float(key), text=value, count=int(num), casepercent=caseP, percent=validP))
        jsonValue["detailValid"].sort(key=lambda x: x["value"], reverse=False)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # if variableVarMissing :
        #     for key,value in json.loads(variableVarMissing).items():
        #         for k,v in missingCount.items():
        #             if key==k:
        #                 num,caseP,validP = float(v),0.0,0.0
        #                 if caseN!=0 :
        #                     caseP=float(v)/invalidN
        #                 if validN!=0 :
        #                     validP=float(v)/validN
        #                 jsonValue["detailInvalid"].append(
        #                     dict(value=float(key),text=value,count=int(num),casepercent=caseP,percent=validP))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 多重响应二分法
def mongo_multiple2_logic(dataSetId, counted_value, OptionID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                          CasesCondition, varMissing):
    # counted_value=1，表示,1为选中；counted_value=0，表示,0为选中
    jsonValue = dict(head=[], detailValid=[], detailInvalid=[])
    try:
        caseN, validN, invalidN, valueCount, varLabel, caseListN = 0.0, 0.0, 0.0, {}, {}, {}
        if not isinstance(OptionID, list):
            return "不是多选题的变量列表类型"
        if counted_value != '1' and counted_value != '0':
            return "counted_value字符值必须是1或0"

        for itemInd, itemOpt in enumerate(OptionID):
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            valueCount[itemInd] = 0
            caseListN[itemInd] = 0.0
            # DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, str(itemOpt))#VariableID + str(itemOpt)
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            DataCount = retFrequency.CountMongo(dataSetId, versionNum,
                                                str(itemOpt), CasesCondition, varMissing)  # VariableID + str(itemOpt),
            # retFrequency.close()
            # varLabel[itemInd] = ""
            # for rowItem in DataVariable:
            #     varLabel[itemInd] = rowItem['varLabel']
            # if isinstance(phrase, list) and len(phrase) > itemInd:
            #     varLabel[itemInd] = phrase[itemInd]
            for dataItem in DataCount:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and \
                        is_number(dataItem['_id']) and (float(dataItem['_id']) == 0 or float(dataItem['_id']) == 1):
                    caseListN[itemInd] += float(dataItem['count'])  # 表示总体样本数量
                    if str(int(float(dataItem['_id']))).strip() == counted_value:
                        valueCount[itemInd] += float(dataItem['count'])
                        validN += float(dataItem['count'])  # 表示总体响应数量
                else:
                    if itemInd == 0: invalidN += float(dataItem['count'])  # 表示没有填0或1的无效数据

        CasesCondition0 = copy.deepcopy(CasesCondition)
        if counted_value == '1': counted_value_object = '0'
        else: counted_value_object = '1'
        for itemOpt in OptionID:
            if CasesCondition0:
                CasesCondition0[str(itemOpt)] = counted_value_object
            else:
                CasesCondition0 = {str(itemOpt): counted_value_object}
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, str(OptionID[0]), CasesCondition0, varMissing)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # retFrequency.close()
        for caseKey, caseValue in caseListN.items():
            if caseN < caseValue: caseN = caseValue
        for j in DataCount:
            caseN = caseN - float(j['count'])
        # retMeta.close()

        caseP, validP = 0.0, 0.0
        if caseN != 0: caseP = float(validN) / float(caseN)
        if caseN + invalidN != 0: validP = float(caseN) / float(caseN + invalidN)
        jsonValue["head"].append(
            dict(varLabel=OptionID, count=int(caseN), caseN=int(caseN), validN=int(validN),
                 # dict(varLabel="", variableID=VariableID, count=int(validN), caseN=int(caseN), validN=int(validN),
                 invalidN=int(invalidN), casepercent=caseP, percent=validP, analysis="multiple two"))
        for k, v in valueCount.items():
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            num, caseP, validP = float(v), 0.0, 0.0  # num=某个多选变量对应的响应数量
            if caseN != 0:
                caseP = float(v) / caseN  # caseP=个案百分比
            if validN != 0:
                validP = float(v) / validN  # validP=响应百分比
            jsonValue["detailValid"].append(
                dict(var_no=float(k) + 1, text=OptionID[k], count=int(num), casepercent=caseP, percent=validP))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 多重响应新增加的类别方法
def mongo_multipleTypeResponse_logic(dataSetId, OptionID, StartValue, EndValue, versionNum, mongodb_cfg, redis_cfg,
                                     analyProcessId, CasesCondition, varMissing):
    jsonValue = dict(head=[], detailValid=[], detailInvalid=[])
    try:
        if not isinstance(OptionID, list):
            jsonValue = "不是多选题的变量列表类型"
            return

        caseN, validN, invalidN, valueCount, varLabel = 0.0, 0.0, 0.0, {}, {}
        for i in range(1, len(OptionID) + 1):
            valueCount[i] = 0

        for itemInd in range(int(StartValue), int(EndValue) + 1):
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            DataCount = retFrequency.CountMongo(dataSetId, versionNum, OptionID[itemInd - 1], CasesCondition, varMissing)
            # retFrequency.close()
            DataSource = []
            for dataItem in DataCount:
                if dataItem['_id'] == '' or dataItem['_id'] is None or str(dataItem['_id']).strip() == '#NULL!':
                    dataItem['_id'] = '0'
                else:
                    dataItem['_id'] = str(int(float(dataItem['_id'])))
                DataSource.append(dataItem)
                # caseN=len(DataSource)
            for j in DataSource:
                # for i in range(0,len(OptionID)):
                if int(j['_id']) in range(0, len(OptionID) + 1):
                    if itemInd == int(StartValue):
                        caseN += float(j['count'])  # 表示总体样本数量
                    if int(j['_id']) != 0:
                        valueCount[int(j['_id'])] += float(j['count'])
                        validN += float(j['count'])  # 表示总体响应数量
                else:
                    if itemInd == int(StartValue): invalidN += float(j['count'])  # 表示没有填0或选项值的无效数据


        caseP, validP = 0.0, 0.0
        if caseN != 0: caseP = float(validN) / float(caseN)
        if validN != 0: validP = float(validN) / float(validN)
        jsonValue["head"].append(
            dict(varLabel=OptionID, count=int(validN), caseN=int(caseN), validN=int(validN),
                 # dict(varLabel="", variableID=VariableID, count=int(validN), caseN=int(caseN), validN=int(validN),
                 invalidN=int(invalidN), casepercent=caseP, percent=validP, analysis="multiple Type"))
        for k, v in valueCount.items():
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            num, caseP, validP = float(v), 0.0, 0.0  # num=某个多选变量对应的响应数量
            if caseN != 0:
                caseP = float(v) / caseN  # caseP=个案百分比
            if validN != 0:
                validP = float(v) / validN  # validP=响应百分比
            jsonValue["detailValid"].append(
                dict(var_no=float(k), text=OptionID[k - 1], count=int(num), casepercent=caseP, percent=validP))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 词云分析
def mongo_wordcloud_logic(dataSetId, VariableID, phrase, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                          CasesCondition, varMissing):
    jsonValue = dict(head=[], detailValid=[])  # type: Dict[Any, List[Any]]
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, VariableID)
        # retMeta.close()
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # retFrequency.close()
        totalN, validN, validP, missingP, varLabel = 0.0, 0.0, 0.0, 0.0, ""
        for rowItem in DataVariable:
            varLabel = rowItem['varLabel']

        # head计算
        DataSource = []
        for dataItem in DataCount:
            DataSource.append(dataItem)
        for j in DataSource:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            totalN += float(j['count'])
            if j['_id'] is not None and str(j['_id']).strip() != '':
                validN += float(j['count'])
        for j in DataSource:
            if j['_id'] is not None and str(j['_id']).strip() != '':
                num, per, perV = float(j['count']), 0.0, 0.0
                if validN != 0:
                    perV = float(j['count']) / float(validN)
                if totalN != 0:
                    per = float(j['count']) / float(totalN)
                jsonValue["detailValid"].append(
                    dict(value='0', text=str(j['_id']).strip(), count=int(num), validpercent=perV, percent=per))
        if float(totalN) != 0:
            if phrase != "":
                varLabel = phrase
            validP = float(validN) / float(totalN)
            missingP = float(totalN - validN) / float(totalN)
            jsonValue["detailValid"].sort(key=lambda x: x["validpercent"], reverse=True)
        jsonValue["head"].append(
            dict(varLabel=varLabel, variableID=VariableID, count=int(validN), totalN=int(totalN), validN=int(validN),
                 validP=validP, missingN=int(totalN - validN), missingP=missingP, analysis="wordcloud"))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<交叉表：列联表分析>----- #
def mongo_crosstabs_logic(dataSetId, RowID, ColumnID, Group, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                          CasesCondition,  varMissing):
    jsonValue = dict(head=[], detailValid=[], detailValidgroup=[], chiSquare=[])
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, ColumnID)
        retCrosstabs = mongoCrosstabsModel(mongodb_cfg)
        DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, RowID, ColumnID, CasesCondition, varMissing)
        # retCrosstabs.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        rowVarLabel, columnVarLabel, rowIDValues, columnIDValues, variableVarMissing, rowMissingValue, \
        rowMissingValueRange, columnMissingValue, columnMissingValueRange = "", "", None, None, None, [], [], [], []
        for rowItem in rowMeta :
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
        #     rowIDValues=rowItem['varValues']
        #     rowVarLabel=rowItem['varLabel']
        for columnItem in columnMeta:
            if 'varMissing' in columnItem:
                variableVarMissing = json.loads(columnItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    columnMissingValue.append(str(variableVarMissing['S_Value']))
        #     columnIDValues=columnItem['varValues']
        #     columnVarLabel=columnItem['varLabel']
        if not rowIDValues or str(rowIDValues).strip() == "" or not check_json_format(str(rowIDValues).strip()):
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, RowID, CasesCondition, varMissing)
            # retFrequency.close()
            index, rowIDValuesJson1, rowIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in rowMissingValue and \
                        not (len(rowMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(rowMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(rowMissingValueRange[1])):
                    rowIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    rowIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson2)))
            else:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson1)))

        if not columnIDValues or str(columnIDValues).strip() == "" or not check_json_format(str(columnIDValues).strip()):
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, ColumnID, CasesCondition, varMissing)
            # retFrequency.close()
            index, columnIDValuesJson1, columnIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in columnMissingValue and \
                        not (len(columnMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(columnMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(columnMissingValueRange[1])):
                    columnIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    columnIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                columnIDValues = json.dumps(dict(ChainMap(*columnIDValuesJson2)))
            else:
                columnIDValues = json.dumps(dict(ChainMap(*columnIDValuesJson1)))
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        allCount, validCount, validP, missingP = 0.0, 0.0, 0.0, 0.0
        DataSource = pd.DataFrame(list(DataCount)).values.tolist()
        if isinstance(DataSource, list) and len(DataSource) > 0:
            for dataItem in DataSource:
                allCount += float(dataItem[1])
            for key, value in json.loads(rowIDValues).items():
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                validN, rowFlag = 0, False
                for k, v in json.loads(columnIDValues).items():
                    for dataItem in DataSource:
                        if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                            str(value).strip() == str(dataItem[0].get(RowID)).strip()) and \
                                ColumnID in dataItem[0].keys() and (
                                str(k).strip() == str(dataItem[0].get(ColumnID)).strip() or
                                str(v).strip() == str(dataItem[0].get(ColumnID)).strip()):
                            validN += float(dataItem[1])
                            validCount += float(dataItem[1])
                            rowFlag = True
                for k, v in json.loads(columnIDValues).items():
                    columnFlag = False
                    for dataItem in DataSource:
                        if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                            str(value).strip() == str(dataItem[0].get(RowID)).strip()) and \
                                ColumnID in dataItem[0].keys() and (
                                str(k).strip() == str(dataItem[0].get(ColumnID)).strip() or
                                str(v).strip() == str(dataItem[0].get(ColumnID)).strip()):
                            num, per, columnFlag = float(dataItem[1]), 0, True
                            if validN != 0:
                                per = float(num) / float(validN)
                            jsonValue["detailValid"].append(dict(valueRow=float(key), textRow=value,
                                                                 valueColumn=float(k),
                                                                 textColumn=v,
                                                                 total=validN, count=num, validpercent=per))
                    if rowFlag and not columnFlag:
                        jsonValue["detailValid"].append(dict(valueRow=float(key), textRow=value,
                                                             valueColumn=float(k),
                                                             textColumn=v,
                                                             total=validN, count=0, validpercent=0))
                option, groupNum = "", 0.0
                if Group and Group != "":
                    groupsplit = Group.split(',')
                    for k, v in json.loads(columnIDValues).items():
                        if k in groupsplit:
                            if option != "":
                                option += ","
                            option += v
                    insertFlag = False
                    for dataItem in DataSource:
                        if RowID in dataItem[0].keys() and key == dataItem[0].get(RowID) and \
                                ColumnID in dataItem[0].keys() and dataItem[0].get(ColumnID) in groupsplit:
                            groupNum += float(dataItem[1])
                            insertFlag = True
                    per = 0.0
                    if validN != 0:
                        per = float(groupNum) / float(validN)
                    if insertFlag:
                        jsonValue["detailValidgroup"].append(dict(valueRow=float(key), textRow=value,
                                                                  valueColumn="", textColumn=option,
                                                                  total=int(validN), count=int(groupNum), validpercent=per))
        jsonValue["detailValid"].sort(key=lambda x: (x["valueRow"], x["valueColumn"]), reverse=False)
        if float(allCount) != 0:
            validP = float(validCount) / float(allCount)
            missingP = float(allCount - validCount) / float(allCount)
        jsonValue["head"].append(
            dict(rowVarLabel=rowVarLabel, columnVarLabel=columnVarLabel, RowID=RowID, ColumnID=ColumnID,
                 count=int(validCount), totalN=int(allCount), validN=int(validCount), validP=validP,
                 invalidN=int(allCount - validCount), invalidP=missingP, analysis="crosstabs"))
        chiSquare_Tests = chiSquareway.run(DataFrame(jsonValue["detailValid"]), "valueRow", "valueColumn")
        jsonValue["chiSquare"].append(chiSquare_Tests)
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<比较均值>----- #
def mongo_comparemeans_logic(dataSetId, RowID, ColumnID, IntervalRange, versionNum, mongodb_cfg, redis_cfg,
                             analyProcessId, CasesCondition, varMissing, replaceText):
    jsonValue = dict(head=[], detailValid=[], variance=[])
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        DataRowID = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        DataColumnID = retMeta.SelectMetaVariable(dataSetId, versionNum, ColumnID)
        retCompareMeans = mongoCompareMeansModel(mongodb_cfg)
        DataCount = retCompareMeans.CompareSumMongo(dataSetId, versionNum, RowID, ColumnID, CasesCondition, varMissing)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        rowVarLabel, columnVarLabel, rowIDValues, anovaArgs, rowIDValuesFlag, replaceFrom, replaceTo = "", "", None, [], True, [], []
        variableVarMissing, rowMissingValue, rowMissingValueRange, columnMissingValue, columnMissingValueRange = \
            None, [], [], [], []
        if replaceText is None:
            replaceText = []
        for i in range(len(replaceText)):
            replaceFrom.append(replaceText[i][0])
            replaceTo.append(replaceText[i][1])

        for rowItem in DataRowID:
            # rowIDValues = rowItem['varValues']
            rowVarLabel = rowItem['varLabel']
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
        for columnItem in DataColumnID:
            columnVarLabel = columnItem['varLabel']
            if 'varMissing' in columnItem:
                variableVarMissing = json.loads(columnItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    columnMissingValue.append(str(variableVarMissing['S_Value']))
        if not rowIDValues or str(rowIDValues).strip() == "" or not check_json_format(str(rowIDValues).strip()):
            rowIDValuesFlag = False
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, RowID, CasesCondition, varMissing)
            # retFrequency.close()
            index, rowIDValuesJson1, rowIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in rowMissingValue and \
                        not (len(rowMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(rowMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(rowMissingValueRange[1])):
                    rowIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    rowIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson2)))
            else:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson1)))

        totalN, validN, validP, invalidP = 0.0, 0.0, 0.0, 0.0
        for dataItem in DataCount:
            totalN += float(dataItem['count'])
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        for key, value in json.loads(rowIDValues).items():
            retCompareMeans = mongoCompareMeansModel(mongodb_cfg)
            if rowIDValuesFlag:
                sortData = retCompareMeans.sortDataMongo(dataSetId, versionNum, RowID, ColumnID,
                                                         key, CasesCondition, varMissing)
            else:
                sortData = retCompareMeans.sortDataMongo(dataSetId, versionNum, RowID, ColumnID,
                                                         value, CasesCondition, varMissing)
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            DataSort = []
            DataList = pd.DataFrame(list(sortData)).dropna().values.tolist()
            if isinstance(DataList, list) and len(DataList) > 0:
                # DataSort = [x for [x] in DataList]
                # replace "replaceTo" with "replaceFrom" [1,2,3]   DataList[i] 2

                for i in range(len(DataList)):
                    if len(DataList[i]) > 0:
                        DataList_i = DataList[i][0]
                        if DataList_i is not None and DataList_i in replaceFrom:
                            replaceIndex = replaceFrom.index(DataList_i)
                            DataList_i = replaceTo[replaceIndex]

                        if DataList_i is not None and DataList_i != '' and is_number(DataList_i) and \
                                DataList_i not in columnMissingValue and not (len(columnMissingValueRange) > 1 and
                                 float(columnMissingValueRange[0]) <= float(DataList_i) <= float(columnMissingValueRange[1])):
                            DataSort.append(float(DataList_i))

                # DataSort = [x for x in DataSort if x != '' and is_number(x)]
                # DataSort = [float(x) for x in DataSort]
            if isinstance(IntervalRange, list):
                DataSortCopy = DataSort[:]
                for num in DataSort:
                    if num < float(IntervalRange[0]) or float(IntervalRange[0]) > float(IntervalRange[1]):
                        DataSortCopy.remove(num)
                DataSort = DataSortCopy
            if len(DataSort) > 0:
                for num in DataSort:
                    anovaArgs.append([num, float(key)])
            if len(DataSort) > 0:
                std = np.std(DataSort, axis=0, ddof=1)              # 数据只有1条会报错，除0错误，返回值nan
                maxData = np.max(DataSort)
                cnt = len(DataSort)
                sumData = np.sum(DataSort)
                minData = np.min(DataSort)
                avg = np.average(DataSort)
                # var = np.var(DataSort)
                var = float(np.cov(DataSort))
                mid = np.median(DataSort)
                gm = pd.Series(data=DataSort)
                mode = gm.mode()[0]
                if str(avg) == 'nan':
                    std = gm.std()
                    avg = gm.mean()
                    sumData = gm.sum()
                    cnt = int(gm.count())
                    maxData = gm.max()
                    minData = gm.min()
                    var = gm.var()
                    mid = gm.median()
                validN += cnt
                jsonValue["detailValid"].append(
                    dict(valueRow=float(key), textRow=value, sum=sumData, count=cnt, average=avg, max=maxData,
                         median=mid, min=minData, mode=mode, stdev=nanToStr(std), Percent5=myNQuartiles(DataSort, 5),
                         Percent25=myNQuartiles(DataSort, 25), Percent75=myNQuartiles(DataSort, 75),
                         Percent95=myNQuartiles(DataSort, 95), variance=nanToStr(var)))
        jsonValue["detailValid"].sort(key=lambda x: x["valueRow"], reverse=False)

        if totalN != 0:
            validP = validN / totalN
            invalidP = (totalN - validN) / totalN
        jsonValue["head"].append(
            dict(rowVarLabel=rowVarLabel, columnVarLabel=columnVarLabel, RowID=RowID, ColumnID=ColumnID,
                 count=int(validN), totalN=int(totalN), validN=int(validN), validP=validP,
                 invalidN=int(totalN - validN), invalidP=invalidP, analysis="comparemeans"))
        try:
            anovaArgsData = pd.DataFrame(anovaArgs, columns=[RowID, ColumnID])
            expr = '{}~C({})'.format(RowID, ColumnID)
            mod = ols(expr, data=anovaArgsData).fit()
            anova_table = sm.stats.anova_lm(mod)
            ret = {'df': list(anova_table.df),
                   'sum_sq': list(anova_table.sum_sq),
                   'mean_sq': list(anova_table.mean_sq),
                   'F': list(anova_table.F)[0],
                   'P': list(anova_table.values.T[-1])[0]}
        except Exception as e:
            ret = {"df": "NaN", "sum_sq": "NaN", "mean_sq": "Nan", "F": "NaN", "P": "NaN"}
        jsonValue["variance"].append(ret)
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<比较均值 简单快速查询>----- #
def mongo_comparemeans2_logic(dataSetId, RowID, ColumnID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                              CasesCondition):
    jsonValue = dict(head=[], detailValid=[])
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        DataRowID = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        DataColumnID = retMeta.SelectMetaVariable(dataSetId, versionNum, ColumnID)
        retCompareMeans = mongoCompareMeansModel(mongodb_cfg)
        DataCount = retCompareMeans.CompareSumMongo(dataSetId, versionNum, RowID, ColumnID, CasesCondition, varMissing)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        rowVarLabel, columnVarLabel, rowIDValues, anovaArgs, rowIDValuesFlag = "", "", None, [], True
        variableVarMissing, rowMissingValue, rowMissingValueRange, columnMissingValue, columnMissingValueRange = \
            None, [], [], [], []
        varMissingKey, varMissingValue = [], []
        for rowItem in DataRowID:
            # rowIDValues = rowItem['varValues']
            rowVarLabel = rowItem['varLabel']
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
                if len(rowMissingValue) > 0:
                    varMissingKey.append(RowID)
                    varMissingValue.append({'$nin': rowMissingValue})
                if len(rowMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[RowID] = {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                          '$lte': float(rowMissingValueRange[1])}}
                    else:
                        CasesCondition = {RowID: {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                           '$lte': float(rowMissingValueRange[1])}}}
        for columnItem in DataColumnID:
            columnVarLabel = columnItem['varLabel']
            if 'varMissing' in columnItem:
                variableVarMissing = json.loads(columnItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    columnMissingValue.append(str(variableVarMissing['S_Value']))
                if len(columnMissingValue) > 0:
                    varMissingKey.append(ColumnID)
                    varMissingValue.append({'$nin': columnMissingValue})
                if len(columnMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[ColumnID] = {'$not': {'$gte': float(columnMissingValueRange[0]),
                                                             '$lte': float(columnMissingValueRange[1])}}
                    else:
                        CasesCondition = {ColumnID: {'$not': {'$gte': float(columnMissingValueRange[0]),
                                                              '$lte': float(columnMissingValueRange[1])}}}
        if not rowIDValues or str(rowIDValues).strip() == "" or not check_json_format(str(rowIDValues).strip()):
            rowIDValuesFlag = False
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, RowID, CasesCondition, varMissing)
            # retFrequency.close()
            index, rowIDValuesJson1, rowIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in rowMissingValue and \
                        not (len(rowMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(rowMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(rowMissingValueRange[1])):
                    rowIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    rowIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson2)))
            else:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson1)))

        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        retCompareMeans = mongoCompareMeansModel(mongodb_cfg)
        DataSum = retCompareMeans.SumMongoCompareAvg(dataSetId, versionNum, RowID, ColumnID, CasesCondition,
                                                     varMissingKey, varMissingValue)
        totalN, validN, validP, invalidP, sumTotal = 0.0, 0.0, 0.0, 0.0, 0.0
        for dataItem in DataCount:
            totalN += float(dataItem['count'])
        for dataItem in DataSum:
            text, avg, sumData, maxData, minData, cnt = None, 0, 0, 0, 0, 0
            if dataItem['_id'][RowID] is not None and str(dataItem['_id'][RowID]).strip() != '' and \
                    str(dataItem['_id'][RowID]).strip() != 'None' and str(dataItem['_id'][RowID]).strip() != 'null':
                text = str(dataItem['_id'][RowID]).strip()
            if dataItem[ColumnID + 'avg'] is not None and \
                    str(dataItem[ColumnID + 'avg']).strip() != '':
                avg = float(str(dataItem[ColumnID + 'avg']).strip())
                sumData = float(str(dataItem[ColumnID + 'sum']).strip())
                maxData = float(str(dataItem[ColumnID + 'max']).strip())
                minData = float(str(dataItem[ColumnID + 'min']).strip())
                dataFlag = True
            else:
                dataFlag = False
            if dataFlag and dataItem['count'] is not None and str(dataItem['count']).strip() != '':
                cnt = float(str(dataItem['count']).strip())
            if dataFlag and text is not None:
                if text in json.loads(rowIDValues).keys():
                    jsonValue["detailValid"].append(
                        dict(valueRow=int(float(text)), textRow=json.loads(rowIDValues)[text], sum=sumData,
                             count=cnt, average=avg, max=maxData, min=minData, ))
                    validN += cnt
                    sumTotal += sumData
        if sumTotal != 0:
            for detailItem in jsonValue["detailValid"]:
                detailItem["validpercent"] = detailItem["sum"] / sumTotal
        jsonValue["detailValid"].sort(key=lambda x: x["valueRow"], reverse=False)
        if totalN != 0:
            validP = validN / totalN
            invalidP = (totalN - validN) / totalN
        jsonValue["head"].append(dict(rowVarLabel=rowVarLabel, columnVarLabel=columnVarLabel, RowID=RowID,
                                      ColumnID=ColumnID, count=int(validN), totalN=int(totalN), validN=int(validN),
                                      length=len(jsonValue["detailValid"]), validP=validP, invalidN=int(totalN - validN),
                                      invalidP=invalidP, analysis="comparemeans"))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<交叉表：多重响应分析:单一变量>----- #
def mongo_crosstabsMultiple_logic(dataSetId, RowID, VariableID, Separator, versionNum, mongodb_cfg, redis_cfg,
                                  analyProcessId, CasesCondition,  varMissing):
    jsonValue = dict(head=[], detailValid=[])
    try:
        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, VariableID)
        retCrosstabs = mongoCrosstabsModel(mongodb_cfg)
        DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, RowID, VariableID, CasesCondition, varMissing)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        rowVarLabel, columnVarLabel, rowIDValues, columnIDValues, variableVarMissing, rowMissingValue, \
        rowMissingValueRange, columnMissingValue, columnMissingValueRange = "", "", None, None, None, [], [], [], []
        for rowItem in rowMeta :
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
        for columnItem in columnMeta:
            if 'varMissing' in columnItem:
                variableVarMissing = json.loads(columnItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    columnMissingValue.append(str(variableVarMissing['S_Value']))
        if not rowIDValues or str(rowIDValues).strip() == "" or not check_json_format(str(rowIDValues).strip()):
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, RowID, CasesCondition, varMissing)
            # retFrequency.close()
            index, rowIDValuesJson1, rowIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in rowMissingValue and \
                        not (len(rowMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(rowMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(rowMissingValueRange[1])):
                    rowIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    rowIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson2)))
            else:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson1)))
        if True:
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            DataCountVar = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
            keys, values, index = [], [], 0
            for j in DataCountVar:
                if j['_id'] is not None and str(j['_id']).strip() != "":
                    if Separator == '1' and "," in j['_id']:
                        varstr = str(j['_id']).strip().split(",")
                    elif Separator == '0' and "." in j['_id']:
                        varstr = str(j['_id']).strip().split(".")
                    else:
                        varstr = [str(j['_id']).strip()]
                    for itemVar in varstr:
                        if itemVar not in values and itemVar not in columnMissingValue and \
                                not (len(columnMissingValueRange) > 1 and is_number(itemVar) and
                                     float(columnMissingValueRange[0]) <= float(itemVar) <= float(
                                            columnMissingValueRange[1])):
                            if is_number(itemVar):
                                index = int(itemVar)
                            else:
                                index += 1
                            keys.append(str(index))
                            values.append(itemVar)
            columnIDValues = json.dumps(dict(zip(keys, values)))
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        allCount, validCount, caseCount, caseP, validP, missingP, delimiter = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, '.'
        DataSource = pd.DataFrame(list(DataCount)).values.tolist()
        if isinstance(DataSource, list) and len(DataSource) > 0:
            for dataItem in DataSource:
                allCount += float(dataItem[1])
            for key, value in json.loads(rowIDValues).items():
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                caseN, validN, valueCount = 0, 0, {}
                for k, v in json.loads(columnIDValues).items():
                    valueCount[k] = 0
                for dataItem in DataSource:
                    if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                        str(value).strip() == str(dataItem[0].get(RowID)).strip()):
                        if "," in str(dataItem[0].get(VariableID)).strip():
                            delimiter = ","
                        check_id = delimiter + str(dataItem[0].get(VariableID)).strip() + delimiter
                        if len(columnMissingValue) > 0:
                            for varMissingValueItem in columnMissingValue:
                                check_id = check_id.replace(delimiter + varMissingValueItem + delimiter, delimiter)
                            if check_id == delimiter or check_id == delimiter + delimiter or \
                                    check_id == delimiter + delimiter + delimiter:
                                check_id = ''
                        if not (not dataItem[0].get(VariableID) or str(dataItem[0].get(VariableID)).strip() == "" or
                                str(dataItem[0].get(VariableID)).strip() == "#NULL!" or check_id == ''):
                            caseN += float(dataItem[1])
                            caseCount += float(dataItem[1])
                            for keyColumn, valueColumn in json.loads(columnIDValues).items():
                                if (delimiter + str(dataItem[0].get(VariableID)) + delimiter).\
                                        find(delimiter + str(keyColumn) + delimiter) >= 0:
                                    for k, v in valueCount.items():
                                        if keyColumn == k:
                                            valueCount[k] = v + float(dataItem[1])
                                            validN += float(dataItem[1])
                                            validCount += float(dataItem[1])
                for keyColumn, valueColumn in json.loads(columnIDValues).items():
                    for k, v in valueCount.items():
                        if str(keyColumn) == str(k):
                            num, caseP, validP = float(v), 0.0, 0.0
                            if caseN != 0:
                                caseP = float(v) / caseN
                            if validN != 0:
                                validP = float(v) / validN
                            jsonValue["detailValid"].append(
                                dict(valueRow=float(key), textRow=value, valueColumn=float(keyColumn),
                                     textColumn=valueColumn, text=valueColumn, count=int(num), casepercent=caseP,
                                     percent=validP, caseCount=caseN))
                            break
        jsonValue["detailValid"].sort(key=lambda x: (x["valueRow"], x["valueColumn"]), reverse=False)
        if float(allCount) != 0:
            validP = float(caseCount) / float(allCount)
            missingP = float(allCount - caseCount) / float(allCount)
        if caseCount != 0: caseP = float(validCount) / float(caseCount)
        jsonValue["head"].append(
            dict(rowVarLabel=rowVarLabel, columnVarLabel=columnVarLabel, RowID=RowID, ColumnID=VariableID,
                 count=int(caseCount), totalN=int(allCount), validN=int(caseCount), validP=validP,caseN=int(caseCount),
                 casepercent=caseP,invalidN=int(allCount - caseCount), invalidP=missingP, analysis="crosstabsMultiple"))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<交叉表：多重响应二分法>----- #
def mongo_crosstabsMultiple2_logic(dataSetId, RowID, counted_value, OptionID, versionNum, mongodb_cfg, redis_cfg,
                                  analyProcessId, CasesCondition,  varMissing):
    jsonValue = dict(head=[], detailValid=[])
    try:
        if not isinstance(OptionID, list):
            return "不是多选题的变量列表类型"
        if counted_value != '1' and counted_value != '0':
            return "counted_value字符值必须是1或0"

        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        retCrosstabs = mongoCrosstabsModel(mongodb_cfg)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        rowVarLabel, rowIDValues, variableVarMissing, rowMissingValue, rowMissingValueRange = "", None, None, [], []
        for rowItem in rowMeta :
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
        if not rowIDValues or str(rowIDValues).strip() == "" or not check_json_format(str(rowIDValues).strip()):
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, RowID, CasesCondition, varMissing)
            # retFrequency.close()
            index, rowIDValuesJson1, rowIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in rowMissingValue and \
                        not (len(rowMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(rowMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(rowMissingValueRange[1])):
                    rowIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    rowIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson2)))
            else:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson1)))

        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        allCount, caseCount, caseP, validP, missingP, validCount = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
        valueCount, caseListN, validN, invalidN, OptionIDKey, OptionIDValue = {}, {}, {}, {}, [], []
        for itemInd, itemOpt in enumerate(OptionID):
            OptionIDKey.append(itemInd)
            OptionIDValue.append(0.0)
        for key, value in json.loads(rowIDValues).items():
            validN[key] = 0
            invalidN[key] = 0
            valueCount[key] = dict(zip(OptionIDKey, OptionIDValue))
            caseListN[key] = dict(zip(OptionIDKey, OptionIDValue))
        for itemInd, itemOpt in enumerate(OptionID):
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, RowID, itemOpt, CasesCondition,
                                                         varMissing)
            DataSource = pd.DataFrame(list(DataCount)).values.tolist()
            for dataItem in DataSource:
                if itemInd == 0: allCount += float(dataItem[1])
                for key, value in json.loads(rowIDValues).items():
                    if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                        str(value).strip() == str(dataItem[0].get(RowID)).strip()):
                        if dataItem[0].get(itemOpt) is not None and str(dataItem[0].get(itemOpt)).strip() != '' and \
                                is_number(dataItem[0].get(itemOpt)) and (float(dataItem[0].get(itemOpt)) == 0 or
                                                                         float(dataItem[0].get(itemOpt)) == 1):
                            caseListN[key][itemInd] += float(dataItem[1])  # 表示总体样本数量
                            if str(int(float( dataItem[0].get(itemOpt)))).strip() == counted_value:
                                valueCount[key][itemInd] += float(dataItem[1])
                                validN[key] += float(dataItem[1])  # 表示总体响应数量
        CasesCondition0 = copy.deepcopy(CasesCondition)
        if counted_value == '1': counted_value_object = '0'
        else: counted_value_object = '1'
        for itemOpt in OptionID:
            if CasesCondition0:
                CasesCondition0[str(itemOpt)] = counted_value_object
            else:
                CasesCondition0 = {str(itemOpt): counted_value_object}
        DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, RowID, str(OptionID[0]), CasesCondition0,
                                                     varMissing)
        DataSource = pd.DataFrame(list(DataCount)).values.tolist()
        for key, value in json.loads(rowIDValues).items():
            caseN = 0
            for caseKey, caseValue in caseListN[key].items():
                if caseN < caseValue: caseN = caseValue
            for dataItem in DataSource:
                if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                    str(value).strip() == str(dataItem[0].get(RowID)).strip()):
                    caseN = caseN - float(dataItem[1])
            caseCount += caseN
            validCount += validN[key]
            for k, v in valueCount[key].items():
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                num, caseP, validP = float(v), 0.0, 0.0  # num=某个多选变量对应的响应数量
                if caseN != 0:
                    caseP = float(v) / caseN  # caseP=个案百分比
                if validN[key] != 0:
                    validP = float(v) / validN[key]  # validP=响应百分比
                jsonValue["detailValid"].append(dict(valueRow=float(key), textRow=value, var_no=float(k) + 1,
                                                     text=OptionID[k], count=int(num), casepercent=caseP,
                                                     percent=validP, caseCount=caseN))
        jsonValue["detailValid"].sort(key=lambda x: (x["valueRow"], x["var_no"]), reverse=False)
        if float(allCount) != 0:
            validP = float(caseCount) / float(allCount)
            missingP = float(allCount - caseCount) / float(allCount)
        if caseCount != 0: caseP = float(validCount) / float(caseCount)
        jsonValue["head"].append(
            dict(rowVarLabel=rowVarLabel, columnVarLabel='', RowID=RowID, ColumnID=OptionID,
                 count=int(caseCount), totalN=int(allCount), validN=int(caseCount), validP=validP,caseN=int(caseCount),
                 casepercent=caseP,invalidN=int(allCount - caseCount), invalidP=missingP, analysis="crosstabsMultiple two"))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<交叉表：多重响应新增加的类别方法>----- #
def mongo_crosstabsMultipleTypeResponse_logic(dataSetId, RowID, OptionID, StartValue, EndValue, versionNum, mongodb_cfg,
                                              redis_cfg,analyProcessId, CasesCondition,  varMissing):
    jsonValue = dict(head=[], detailValid=[])
    try:
        if not isinstance(OptionID, list):
            return "不是多选题的变量列表类型"

        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        retCrosstabs = mongoCrosstabsModel(mongodb_cfg)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        rowVarLabel, rowIDValues, variableVarMissing, rowMissingValue, rowMissingValueRange = "", None, None, [], []
        for rowItem in rowMeta :
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
        if not rowIDValues or str(rowIDValues).strip() == "" or not check_json_format(str(rowIDValues).strip()):
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            RowData = retFrequency.CountMongo(dataSetId, versionNum, RowID, CasesCondition, varMissing)
            # retFrequency.close()
            index, rowIDValuesJson1, rowIDValuesJson2, numFlag = 0, [], [], True
            for dataItem in RowData:
                if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and str(dataItem['_id']).strip() \
                        not in rowMissingValue and \
                        not (len(rowMissingValueRange) > 1 and is_number(str(dataItem['_id']).strip()) and
                             float(rowMissingValueRange[0]) <= float(str(dataItem['_id']).strip()) <=
                             float(rowMissingValueRange[1])):
                    rowIDValuesJson1.append({str(index + 1): str(dataItem['_id']).strip()})
                    rowIDValuesJson2.append({str(dataItem['_id']).strip(): str(dataItem['_id']).strip()})
                    if not is_number(str(dataItem['_id']).strip()):
                        numFlag = False
                    index += 1
            if numFlag:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson2)))
            else:
                rowIDValues = json.dumps(dict(ChainMap(*rowIDValuesJson1)))

        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        allCount, caseCount, caseP, validP, missingP, validCount = 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
        valueCount, caseListN, validN, invalidN, OptionIDKey, OptionIDValue = {}, {}, {}, {}, [], []
        for itemInd in range(1, len(OptionID) + 1):
            OptionIDKey.append(itemInd)
            OptionIDValue.append(0.0)
        for itemInd, itemOpt in enumerate(OptionID):
            OptionIDKey.append(itemInd)
            OptionIDValue.append(0.0)
        for key, value in json.loads(rowIDValues).items():
            validN[key] = 0
            invalidN[key] = 0
            valueCount[key] = dict(zip(OptionIDKey, OptionIDValue))
            caseListN[key] = dict(zip(OptionIDKey, OptionIDValue))
        for itemInd in range(int(StartValue), int(EndValue) + 1):
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, RowID, OptionID[itemInd - 1],
                                                         CasesCondition, varMissing)
            DataCountList = pd.DataFrame(list(DataCount)).values.tolist()
            DataSource = {}
            for key, value in json.loads(rowIDValues).items():
                DataSource[key] = []
            for dataItem in DataCountList:
                for key, value in json.loads(rowIDValues).items():
                    if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                        str(value).strip() == str(dataItem[0].get(RowID)).strip()):
                        if dataItem[0].get(OptionID[itemInd - 1]) == '' or \
                                dataItem[0].get(OptionID[itemInd - 1]) is None or \
                                str(dataItem[0].get(OptionID[itemInd - 1])).strip() == '#NULL!':
                            dataItem[0][OptionID[itemInd - 1]] = '0'
                        else:
                            dataItem[0][OptionID[itemInd - 1]] = str(int(float(dataItem[0].get(OptionID[itemInd - 1]))))
                        DataSource[key].append(dataItem)
            for key, value in DataSource.items():
                for valueItem in value:
                    if int(valueItem[0].get(OptionID[itemInd - 1])) in range(0, len(OptionID) + 1):
                        if itemInd == int(StartValue):
                            caseListN[key][itemInd] += float(valueItem[1])  # 表示总体样本数量
                        if int(valueItem[0].get(OptionID[itemInd - 1])) != 0:
                            valueCount[key][itemInd] += float(valueItem[1])
                            validN[key] += float(valueItem[1])  # 表示总体响应数量
                        if itemInd == 0: allCount += float(valueItem[1])
        CasesCondition0 = copy.deepcopy(CasesCondition)
        for itemOpt in OptionID:
            if CasesCondition0:
                CasesCondition0[str(itemOpt)] = '0'
            else:
                CasesCondition0 = {str(itemOpt): '0'}
        DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, RowID, str(OptionID[0]), CasesCondition0,
                                                     varMissing)
        DataSource = pd.DataFrame(list(DataCount)).values.tolist()
        for key, value in json.loads(rowIDValues).items():
            caseN = 0
            for caseKey, caseValue in caseListN[key].items():
                if caseN < caseValue: caseN = caseValue
            for dataItem in DataSource:
                if RowID in dataItem[0].keys() and (str(key).strip() == str(dataItem[0].get(RowID)).strip() or
                                                    str(value).strip() == str(dataItem[0].get(RowID)).strip()):
                    caseN = caseN - float(dataItem[1])
            caseCount += caseN
            validCount += validN[key]
            for k, v in valueCount[key].items():
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                num, caseP, validP = float(v), 0.0, 0.0  # num=某个多选变量对应的响应数量
                if caseN != 0:
                    caseP = float(v) / caseN  # caseP=个案百分比
                if validN[key] != 0:
                    validP = float(v) / validN[key]  # validP=响应百分比
                jsonValue["detailValid"].append(dict(valueRow=float(key), textRow=value, var_no=float(k),
                                                     text=OptionID[k - 1], count=int(num), casepercent=caseP,
                                                     percent=validP, caseCount=caseN))
        jsonValue["detailValid"].sort(key=lambda x: (x["valueRow"], x["var_no"]), reverse=False)
        if float(allCount) != 0:
            validP = float(caseCount) / float(allCount)
            missingP = float(allCount - caseCount) / float(allCount)
        if caseCount != 0: caseP = float(validCount) / float(caseCount)
        jsonValue["head"].append(
            dict(rowVarLabel=rowVarLabel, columnVarLabel='', RowID=RowID, ColumnID=OptionID,
                 count=int(caseCount), totalN=int(allCount), validN=int(caseCount), validP=validP,caseN=int(caseCount),
                 casepercent=caseP,invalidN=int(allCount - caseCount), invalidP=missingP, analysis="crosstabsMultiple Type"))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<交叉表：多重响应与多重响应交叉>----- #
def mongo_multipleAndMultipleCross_logic(dataSetId, counted_value_row, OptionID_row, counted_value_column,
                                         OptionID_column, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                         CasesCondition, varMissing):
    # counted_value=1，表示,1为选中；counted_value=0，表示,0为选中
    jsonValue, OptionNameRow, OptionNameColumn, var_no = dict(head=[], detailValid=[], detailInvalid=[]), [], [], 0
    try:
        varLabel_row, varLabel_column, caseTotal, validTotal, invalidTotal = '', '', 0.0, 0.0, 0.0
        if not isinstance(OptionID_row, list):
            return "行变量不是多选题的变量列表类型"
        if counted_value_row != '1' and counted_value_row != '0':
            return "counted_value字符值必须是1或0"
        if not isinstance(OptionID_column, list):
            return "列变量不是多选题的变量列表类型"
        if counted_value_column != '1' and counted_value_column != '0':
            return "counted_value字符值必须是1或0"

        retMeta = select_meta_variable(mongodb_cfg)
        DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, OptionID_row[0][:OptionID_row[0].rfind('S')])
        for rowItem in DataVariable:
            varLabel_row = rowItem['varLabel']
        DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, OptionID_column[0][:OptionID_column[0].rfind('S')])
        for rowItem in DataVariable:
            varLabel_column = rowItem['varLabel']

        for itemIndRow, itemOptRow in enumerate(OptionID_row):
            caseN, validN, invalidN, valueCount, caseListN, OptionNameFlag = 0.0, 0.0, 0.0, {}, {}, False
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, itemOptRow)
            for rowItem in DataVariable:
                OptionNameRow.append(rowItem['varLabel'])
                OptionNameFlag = True
            if not OptionNameFlag: OptionNameRow.append('')
            CasesConditionCopy = copy.deepcopy(CasesCondition)
            if CasesConditionCopy:
                CasesConditionCopy[str(itemOptRow)] = counted_value_row
            else:
                CasesConditionCopy = {str(itemOptRow): counted_value_row}

            for itemInd, itemOpt in enumerate(OptionID_column):
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                valueCount[itemInd] = 0
                caseListN[itemInd] = 0.0
                if itemIndRow == 0:
                    DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, itemOpt)
                    OptionNameFlag = False
                    for rowItem in DataVariable:
                        OptionNameColumn.append(rowItem['varLabel'])
                        OptionNameFlag = True
                    if not OptionNameFlag: OptionNameColumn.append('')

                retFrequency = mongoFrequencyModel(mongodb_cfg)
                DataCount = retFrequency.CountMongo(dataSetId, versionNum,
                                                    str(itemOpt), CasesConditionCopy, varMissing)  # VariableID + str(itemOpt),

                for dataItem in DataCount:
                    if dataItem['_id'] is not None and str(dataItem['_id']).strip() != '' and \
                            is_number(dataItem['_id']) and (float(dataItem['_id']) == 0 or float(dataItem['_id']) == 1):
                        caseListN[itemInd] += float(dataItem['count'])  # 表示总体样本数量
                        if str(int(float(dataItem['_id']))).strip() == counted_value_column:
                            valueCount[itemInd] += float(dataItem['count'])
                            validN += float(dataItem['count'])  # 表示总体响应数量
                    else:
                        if itemInd == 0: invalidN += float(dataItem['count'])  # 表示没有填0或1的无效数据

            CasesCondition0 = copy.deepcopy(CasesConditionCopy)
            if counted_value_column == '1': counted_value_object = '0'
            else: counted_value_object = '1'
            for itemOpt in OptionID_column:
                if CasesCondition0:
                    CasesCondition0[str(itemOpt)] = counted_value_object
                else:
                    CasesCondition0 = {str(itemOpt): counted_value_object}
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            DataCount = retFrequency.CountMongo(dataSetId, versionNum, str(OptionID_column[0]), CasesCondition0, varMissing)
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            for caseKey, caseValue in caseListN.items():
                if caseN < caseValue: caseN = caseValue
            for j in DataCount:
                caseN = caseN - float(j['count'])
            caseTotal += caseN
            validTotal += validN
            invalidTotal += invalidN

            for k, v in valueCount.items():
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                var_no += 1
                num, caseP, validP = float(v), 0.0, 0.0  # num=某个多选变量对应的响应数量
                if caseN != 0:
                    caseP = float(v) / caseN  # caseP=个案百分比
                if validN != 0:
                    validP = float(v) / validN  # validP=响应百分比
                jsonValue["detailValid"].append(
                    dict(var_no=var_no, valueRow=OptionID_row[itemIndRow], textRow=OptionNameRow[itemIndRow],
                         valueColumn=OptionID_column[k],  textColumn=OptionNameColumn[k], text=OptionNameColumn[k],
                         count=int(num), casepercent=caseP, percent=validP, caseCount=caseN))

        retCrosstabs = mongoCrosstabsModel(mongodb_cfg)
        DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, OptionID_row[0], OptionID_column[0],
                                                     CasesCondition, varMissing)
        DataSource = pd.DataFrame(list(DataCount)).values.tolist()
        countTotal, allTotal = 0.0, 0.0
        for dataItem in DataSource:
            if OptionID_row[0] in dataItem[0].keys() and \
                    (str(dataItem[0].get(OptionID_row[0])).strip() == '0' or
                     str(dataItem[0].get(OptionID_row[0])).strip() == '1') and \
                    OptionID_column[0] in dataItem[0].keys() and \
                    (str(dataItem[0].get(OptionID_column[0])).strip() == '0' or
                     str(dataItem[0].get(OptionID_column[0])).strip() == '1'):
                countTotal += float(dataItem[1])
            allTotal += float(dataItem[1])

        invalidP, validP = 0.0, 0.0
        if allTotal != 0: validP = float(countTotal) / float(allTotal)
        if allTotal != 0: invalidP = float(allTotal - countTotal) / float(allTotal)
        jsonValue["head"].append(
            dict(varLabelRow=varLabel_row, varLabelColumn=varLabel_column, count=int(countTotal), caseN=int(caseTotal),
                 validN=int(countTotal), invalidN=int(allTotal - countTotal), invalidpercent=invalidP,
                 validpercent=validP, analysis="multipleAndMultiple"))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<交叉表：多重响应与单选题应交叉>----- #
def mongo_multipleAndSingleCross_logic(dataSetId, counted_value_row, OptionID_row, columnID, versionNum, mongodb_cfg,
                                       redis_cfg, analyProcessId, CasesCondition, varMissing):
    # counted_value=1，表示,1为选中；counted_value=0，表示,0为选中
    jsonValue, OptionNameRow, OptionNameColumn, var_no = dict(head=[], detailValid=[], detailInvalid=[]), [], [], 0
    try:
        varLabel_row, varLabel_column, validTotal, invalidTotal, columnValues, index = '', '', 0.0, 0.0, None, 0
        if not isinstance(OptionID_row, list):
            return "行变量不是多选题的变量列表类型"
        if counted_value_row != '1' and counted_value_row != '0':
            return "counted_value字符值必须是1或0"

        retMeta = select_meta_variable(mongodb_cfg)
        DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, OptionID_row[0][:OptionID_row[0].rfind('S')])
        for rowItem in DataVariable:
            varLabel_row = rowItem['varLabel']
        DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, columnID)
        for rowItem in DataVariable:
            varLabel_column = rowItem['varLabel']
            if 'varValues' in rowItem:
                columnValues = rowItem['varValues']

        for itemIndRow, itemOptRow in enumerate(OptionID_row):
            OptionNameFlag = False
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            DataVariable = retMeta.SelectMetaVariable(dataSetId, versionNum, itemOptRow)
            for rowItem in DataVariable:
                OptionNameRow.append(rowItem['varLabel'])
                OptionNameFlag = True
            if not OptionNameFlag: OptionNameRow.append('')
            CasesConditionCopy = copy.deepcopy(CasesCondition)
            if CasesConditionCopy:
                CasesConditionCopy[str(itemOptRow)] = counted_value_row
            else:
                CasesConditionCopy = {str(itemOptRow): counted_value_row}

            # head计算
            validP, invalidP, missingP, DataSource, totalN, validN, invalidN = 0.0, 0.0, 0.0, [], 0, 0, 0
            retFrequency = mongoFrequencyModel(mongodb_cfg)
            DataCount = retFrequency.CountMongo(dataSetId, versionNum, columnID, CasesConditionCopy, varMissing)
            for dataItem in DataCount:
                DataSource.append(dataItem)

            for j in DataSource:
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                totalN += float(j['count'])
                if j['_id'] is not None and str(j['_id']).strip() != '' and str(j['_id']).strip() != '#NULL!':
                    validN += float(j['count'])
            for j in DataSource:
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                if j['_id'] is not None and str(j['_id']).strip() != '' and str(j['_id']).strip() != '#NULL!':
                    num, per, perV = float(j['count']), 0.0, 0.0
                    index += 1
                    if validN != 0:
                        perV = float(j['count']) / float(validN)
                    if totalN != 0:
                        per = float(j['count']) / float(totalN)
                    valueColumn = str(j['_id']).strip()
                    if is_number(str(j['_id']).strip()) and columnValues != '' and check_json_format(columnValues):
                        textColumn = str(j['_id']).strip()
                        for key, value in json.loads(columnValues).items():
                            if float(str(j['_id']).strip()) == float(key):
                                textColumn = str(value).strip()
                                break
                    else:
                        textColumn = str(j['_id']).strip()
                    jsonValue["detailValid"].append(
                        dict(index=index, valueRow=OptionID_row[itemIndRow], textRow=OptionNameRow[itemIndRow],
                             valueColumn=valueColumn, textColumn=textColumn, text=textColumn, count=int(num),
                             validpercent=perV, percent=per))
            validTotal += validN
            invalidTotal += invalidN
        jsonValue["detailValid"].sort(key=lambda x: (x["valueRow"], x["valueColumn"]), reverse=False)

        retCrosstabs = mongoCrosstabsModel(mongodb_cfg)
        DataCount = retCrosstabs.CrosstabsCountMongo(dataSetId, versionNum, OptionID_row[0], columnID,
                                                     CasesCondition, varMissing)
        DataSource = pd.DataFrame(list(DataCount)).values.tolist()
        countTotal, allTotal = 0.0, 0.0
        for dataItem in DataSource:
            if OptionID_row[0] in dataItem[0].keys() and \
                    (str(dataItem[0].get(OptionID_row[0])).strip() == '0' or
                     str(dataItem[0].get(OptionID_row[0])).strip() == '1') and \
                    columnID in dataItem[0].keys() and str(dataItem[0].get(columnID)).strip() is not None and \
                    str(dataItem[0].get(columnID)).strip() != '' and str(dataItem[0].get(columnID)).strip() != '#NULL!':
                countTotal += float(dataItem[1])
            allTotal += float(dataItem[1])
        invalidP, validP = 0.0, 0.0
        if allTotal != 0: invalidP = float(allTotal - countTotal) / float(allTotal)
        if allTotal != 0: validP = float(countTotal) / float(allTotal)
        jsonValue["head"].append(
            dict(varLabelRow=varLabel_row, varLabelColumn=varLabel_column, count=int(countTotal), validN=int(validTotal),
                 invalidN=int(allTotal - countTotal), validpercent=validP, invalidpercent=invalidP,
                 analysis="multipleAndSingle"))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<排序题：排序题分析>----- #
def mongo_sort_logic(dataSetId, VariableID1, VariableID2, VariableID3, versionNum, mongodb_cfg, redis_cfg,
                     analyProcessId, CasesCondition, varMissing):
    jsonValue = dict(head=[], detailValid=[])
    try:
        retSort = mongoSortModel(mongodb_cfg)
        DataCount = retSort.SortMongo(dataSetId, versionNum, VariableID1, VariableID2, VariableID3, CasesCondition,
                                      varMissing)
        # retSort.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        varLabel1, varLabel2, varLabel3, varValues, option = "", "", "", "", []
        # for rowItem in DataRowID1 :
        #     varValues=rowItem['varValues']
        #     varLabel1=rowItem['varLabel']
        # for rowItem in DataRowID2 :
        #     varLabel2=rowItem['varLabel']
        # for rowItem in DataRowID3 :
        #     varLabel3=rowItem['varLabel']
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataOption = retFrequency.CountMongo(dataSetId, versionNum, VariableID1, CasesCondition, varMissing)
        for j in DataOption:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            if j['_id'] is not None and str(j['_id']).strip() != '':
                option.append(j['_id'])
        DataOption = retFrequency.CountMongo(dataSetId, versionNum, VariableID2, CasesCondition, varMissing)
        for j in DataOption:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            if j['_id'] is not None and str(j['_id']).strip() != '' and str(j['_id']).strip() not in option:
                option.append(j['_id'])
        DataOption = retFrequency.CountMongo(dataSetId, versionNum, VariableID3, CasesCondition, varMissing)
        for j in DataOption:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            if j['_id'] is not None and str(j['_id']).strip() != '' and str(j['_id']).strip() not in option:
                option.append(j['_id'])
        # retFrequency.close()

        lists = np.empty(shape=[0, len(option)], dtype=int)
        allCount, validCount, validP, missingP = 0.0, 0.0, 0.0, 0.0
        for dataItem in DataCount:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            allCount += float(dataItem['count'])
            if VariableID1 in dataItem['_id'].keys() and VariableID2 in dataItem['_id'].keys() and \
                    VariableID3 in dataItem['_id'].keys():
                validCount += float(dataItem['count'])
                for m in range(int(dataItem['count'])):
                    if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                    counts = []
                    for n in range(len(option)):
                        if str(option[n]) == str(dataItem['_id'].get(VariableID1)).strip() or \
                                str(option[n]) == str(dataItem['_id'].get(VariableID2)).strip() or \
                                str(option[n]) == str(dataItem['_id'].get(VariableID3)).strip():
                            if str(option[n]) == str(dataItem['_id'].get(VariableID1)).strip():
                                counts.append(5)
                            elif str(option[n]) == str(dataItem['_id'].get(VariableID2)).strip():
                                counts.append(3)
                            else:
                                counts.append(1)
                        else:
                            counts.append(0)
                    lists = np.append(lists, [counts], axis=0)
        for n in range(len(option)):
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            DataSort = []
            for m in range(int(validCount)):
                DataSort.append(float(lists[m][n]))
            std = np.std(DataSort, axis=0, ddof=1)             # 数据只有1条会报错，除0错误，返回值nan
            maxData = np.max(DataSort)
            cnt = len(DataSort)
            sumData = np.sum(DataSort)
            minData = np.min(DataSort)
            avg = np.average(DataSort)
            var = np.var(DataSort)
            mid = np.median(DataSort)
            counts = np.bincount(DataSort)
            mode = np.argmax(counts)
            if varValues == '' or check_json_format(varValues) == False:
                if is_number(option[n]):
                    index = int(float(option[n]))
                else:
                    index = n
                jsonValue["detailValid"].append(
                    dict(value=index, text=option[n], sum=sumData, count=cnt, average=avg, max=maxData,
                         median=mid, min=minData, mode=mode, stdev=nanToStr(std), variance=nanToStr(var)))
            else:
                optionNM = ''
                for key, value in json.loads(varValues).items():
                    if float(key) == float(option[n]):
                        optionNM = value
                jsonValue["detailValid"].append(
                    dict(value=float(option[n]), text=optionNM, sum=sumData, count=cnt, average=avg, max=maxData,
                         median=mid, min=minData, mode=mode, stdev=nanToStr(std), variance=nanToStr(var)))
        if float(allCount) != 0:
            validP = float(validCount) / float(allCount)
            missingP = float(allCount - validCount) / float(allCount)
        jsonValue["head"].append(
            dict(varLabel1=varLabel1, varLabel2=varLabel2, varLabel3=varLabel3, variableID1=VariableID1,
                 variableID2=VariableID2, variableID3=VariableID3, count=int(validCount), totalN=int(allCount),
                 validN=int(validCount), validP=validP, invalidN=int(allCount - validCount), invalidP=missingP,
                 analysis="sort"))
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<线性回归>----- #
def mongo_LinearRegressionDetail_logic(dataSetId, RowID, ColumnID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                       CasesCondition, varMissing):
    jsonValue = ''
    try:
        variableVarMissing, rowMissingValue, rowMissingValueRange, columnMissingValue, columnMissingValueRange = \
            None, [], [], [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        for rowItem in rowMeta:
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
                if len(rowMissingValue) > 0:
                    varMissingKey.append(RowID)
                    varMissingValue.append({'$nin': rowMissingValue})
                if len(rowMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[RowID] = {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                          '$lte': float(rowMissingValueRange[1])}}
                    else:
                        CasesCondition = {RowID: {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                           '$lte': float(rowMissingValueRange[1])}}}
        xVarName, yVarName = [], []
        xVarName.append(RowID)
        if isinstance(ColumnID, list):
            yVarName = ColumnID
        else:
            yVarName.append(ColumnID)
        for yVarNameItemIndex, yVarNameItem in enumerate(yVarName):
            columnMissingValue.append([])
            columnMissingValueRange.append([])
            columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, yVarNameItem)
            for columnItem in columnMeta:
                if 'varMissing' in columnItem:
                    variableVarMissing = json.loads(columnItem['varMissing'])
                    for valueIndex in range(1, 4):
                        if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValue[yVarNameItemIndex]. \
                                append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                        if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValueRange[yVarNameItemIndex]. \
                                append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                    if 'S_Value' in variableVarMissing.keys():
                        columnMissingValue[yVarNameItemIndex].append(str(variableVarMissing['S_Value']))
                    if len(columnMissingValue[yVarNameItemIndex]) > 0:
                        varMissingKey.append(yVarNameItem)
                        varMissingValue.append({'$nin': columnMissingValue[yVarNameItemIndex]})
                    if len(columnMissingValueRange[yVarNameItemIndex]) > 0:
                        if CasesCondition:
                            CasesCondition[yVarNameItem] = \
                                {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                          '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}
                        else:
                            CasesCondition = \
                                {yVarNameItem: {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                                         '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}}
        linear_obj = mongoLinearRegressionAnalyModel(mongodb_cfg)
        linear_data = linear_obj.showDatas(dataSetId, versionNum, RowID, ColumnID, CasesCondition, varMissingKey,
                                           varMissingValue)
        # linear_obj.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        df_dropna = DataFrame(linear_data, dtype=np.float64).dropna()
        df_standard = DataFrame()
        for i in xVarName + yVarName:
            m = df_dropna[i].mean()
            std = df_dropna[i].std()
            lambda_format = lambda x: (x - m) / std
            df_standard[i] = df_dropna[i].apply(lambda_format)

        # 一个因变量，多个自变量
        myDmatricesStr = " {} ~ {}".format(xVarName[0], " + ".join(yVarName))
        y, x = dmatrices(myDmatricesStr, data=df_dropna, return_type='dataframe')
        y_standard, x_standard = dmatrices(myDmatricesStr, data=df_standard, return_type='dataframe')

        mod = sm.OLS(y, x)
        mod_standard = sm.OLS(y_standard, x_standard)

        res = mod.fit()
        res_standard = mod_standard.fit()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # print(list(res_standard.params))
        # print(res_standard.summary())

        model = {
            'n': int(res.nobs),
            'df': res.df_model,
            'df_resid': res.df_resid,
            'r': math.sqrt(res.rsquared),
            'r_squared': '{:.5f}'.format(res.rsquared),
            'r_squared_adj': '{:.5f}'.format(res.rsquared_adj),
            'f_statistic': '{:.5f}'.format(res.fvalue),
            'prob_f_statistic': '{:.5f}'.format(res.f_pvalue),
        }
        coefficient = {
            "standard_coeff": ['.'] + list(res_standard.params)[1:],
            'coefficient': list(res.params),
            'std': list(np.diag(np.sqrt(res.cov_params()))),
            't': list(res.tvalues),
            'sig': [float(i) for i in
                    ("".join("{:.4f}," * len(res.pvalues)).format(*list(res.pvalues))).rstrip(",").split(",")]
        }
        jsonValue = {'model': model, 'coefficient': coefficient}
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<T检验>----- #独立样本T检验
def mongo_Ttest_indResultDetail_logic(dataSetId, RowID, ColumnID, specifiedValue1, specifiedValue2, versionNum,
                                      mongodb_cfg, redis_cfg, analyProcessId, CasesCondition, varMissing):
    jsonValue = ''
    try:
        variableVarMissing, rowMissingValue, rowMissingValueRange, columnMissingValue, columnMissingValueRange = \
            None, [], [], [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, RowID)
        for rowItem in rowMeta:
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
                if len(rowMissingValue) > 0:
                    varMissingKey.append(RowID)
                    varMissingValue.append({'$nin': rowMissingValue})
                if len(rowMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[RowID] = {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                          '$lte': float(rowMissingValueRange[1])}}
                    else:
                        CasesCondition = {RowID: {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                           '$lte': float(rowMissingValueRange[1])}}}
        columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, ColumnID)
        for columnItem in columnMeta:
            if 'varMissing' in columnItem:
                variableVarMissing = json.loads(columnItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    columnMissingValue.append(str(variableVarMissing['S_Value']))
                if len(columnMissingValue) > 0:
                    varMissingKey.append(ColumnID)
                    varMissingValue.append({'$nin': columnMissingValue})
                if len(columnMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[ColumnID] = {'$not': {'$gte': float(columnMissingValueRange[0]),
                                                             '$lte': float(columnMissingValueRange[1])}}
                    else:
                        CasesCondition = {ColumnID: {'$not': {'$gte': float(columnMissingValueRange[0]),
                                                              '$lte': float(columnMissingValueRange[1])}}}
        tTestObj = mongoLinearRegressionAnalyModel(mongodb_cfg)
        tTestData = tTestObj.showDatas(dataSetId, versionNum, RowID, ColumnID, CasesCondition, varMissingKey,
                                       varMissingValue)
        # tTestObj.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        df_dropna = DataFrame(tTestData, dtype=np.float64).dropna()
        A = df_dropna[df_dropna[RowID] == float(str(specifiedValue1))][ColumnID]
        B = df_dropna[df_dropna[RowID] == float(str(specifiedValue2))][ColumnID]
        DataSort = [A.values.tolist(), B.values.tolist()]
        F, Sig = tuple(stats.levene(A, B, center="mean"))

        EqualTtestValue = tuple(stats.ttest_ind(A, B))
        UnequalTtestValue = tuple(stats.ttest_ind(A, B, equal_var=False))
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return

        jsonValue = {"F": F, "Sig": Sig, "t_sig": EqualTtestValue if Sig > 0.05 else UnequalTtestValue,
                     "type": "方差齐性" if Sig > 0.05 else "方差不齐性", "detailValid": []}
        for DataSortIndex, DataSortItem in enumerate(DataSort):
            if len(DataSortItem) > 0:
                std = np.std(DataSortItem, axis=0, ddof=1)              # 数据只有1条会报错，除0错误，返回值nan
                maxData = np.max(DataSortItem)
                cnt = len(DataSortItem)
                sumData = np.sum(DataSortItem)
                minData = np.min(DataSortItem)
                avg = np.average(DataSortItem)
                var = float(np.cov(DataSortItem))
                mid = np.median(DataSortItem)
                gm = pd.Series(data=DataSortItem)
                mode = gm.mode()[0]
                if str(avg) == 'nan':
                    std = gm.std()
                    avg = gm.mean()
                    sumData = gm.sum()
                    cnt = int(gm.count())
                    maxData = gm.max()
                    minData = gm.min()
                    var = gm.var()
                    mid = gm.median()
                if DataSortIndex == 0: valueRow = float(specifiedValue1)
                else: valueRow = float(specifiedValue2)
                jsonValue["detailValid"].append(
                    dict(valueRow=valueRow, textRow='', sum=sumData, count=cnt, average=avg, max=maxData,
                         median=mid, min=minData, mode=mode, stdev=nanToStr(std), Percent5=myNQuartiles(DataSortItem, 5),
                         Percent25=myNQuartiles(DataSortItem, 25), Percent75=myNQuartiles(DataSortItem, 75),
                         Percent95=myNQuartiles(DataSortItem, 95), variance=nanToStr(var)))
        jsonValue["detailValid"].sort(key=lambda x: x["valueRow"], reverse=False)
        # 计算基本统计量
        n1, n2 = jsonValue["detailValid"][0]['count'], jsonValue["detailValid"][1]["count"]
        std1, std2 = jsonValue["detailValid"][0]["stdev"], jsonValue["detailValid"][1]["stdev"]  # 使用 ddof=1 计算样本标准差
        mean_diff = jsonValue["detailValid"][0]["average"] - jsonValue["detailValid"][1]["average"]

        # 1. 假定等方差（Pooled Variance）
        # 合并方差
        pooled_var = ((n1 - 1) * std1 ** 2 + (n2 - 1) * std2 ** 2) / (n1 + n2 - 2)
        # 标准误差
        se_pooled = np.sqrt(pooled_var * (1 / n1 + 1 / n2))
        # 自由度
        df_pooled = n1 + n2 - 2
        # T 分布的临界值（95% 置信水平）
        alpha = 0.05
        t_critical_pooled = stats.t.ppf(1 - alpha / 2, df_pooled)
        # 置信区间
        ci_lower_pooled = mean_diff - t_critical_pooled * se_pooled
        ci_upper_pooled = mean_diff + t_critical_pooled * se_pooled

        # 2. 不假定等方差（Welch's T-test）
        # 标准误差
        se_welch = np.sqrt(std1 ** 2 / n1 + std2 ** 2 / n2)
        # 自由度（Welch-Satterthwaite 公式）
        df_welch = (std1 ** 2 / n1 + std2 ** 2 / n2) ** 2 / (
                    (std1 ** 2 / n1) ** 2 / (n1 - 1) + (std2 ** 2 / n2) ** 2 / (n2 - 1))
        # T 分布的临界值（95% 置信水平）
        t_critical_welch = stats.t.ppf(1 - alpha / 2, df_welch)
        # 置信区间
        ci_lower_welch = mean_diff - t_critical_welch * se_welch
        ci_upper_welch = mean_diff + t_critical_welch * se_welch
        if Sig > 0.05:
            jsonValue["CI95"] = [ci_lower_pooled, ci_upper_pooled]
        else:
            jsonValue["CI95"] = [ci_lower_welch, ci_upper_welch]
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 单样本T检验
def mongo_Ttest_SingleSample_logic(dataSetId, VariableID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                   CasesCondition, varMissing):
    jsonValue = ''
    try:
        variableVarMissing, variableMissingValue, variableMissingValueRange = None, [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, VariableID)
        for rowItem in rowMeta:
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        variableMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        variableMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    variableMissingValue.append(str(variableVarMissing['S_Value']))
                if len(variableMissingValue) > 0:
                    varMissingKey.append(VariableID)
                    varMissingValue.append({'$nin': variableMissingValue})
                if len(variableMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[VariableID] = {'$not': {'$gte': float(variableMissingValueRange[0]),
                                                               '$lte': float(variableMissingValueRange[1])}}
                    else:
                        CasesCondition = {VariableID: {'$not': {'$gte': float(variableMissingValueRange[0]),
                                                                '$lte': float(variableMissingValueRange[1])}}}
        singleObj = mongoMeansModel(mongodb_cfg)
        Single_data = singleObj.SumMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissingKey,
                                         varMissingValue)
        # singleObj.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return

        df = DataFrame(Single_data, dtype=np.float64).dropna()
        n = int(df.count())
        df_value = n - 1
        # print("df_value：", df_value) 自由度
        meand_data = float(df.mean())
        sample_std = float(df.std())
        # 标准误差=样本标准差/n的开方
        se = sample_std / np.sqrt(n)
        # print("标准误差: ", se)
        t, pvalue = stats.ttest_1samp(df, 0.0)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # 计算 95% 置信区间
        alpha = 0.05
        df = n - 1
        ci_lower, ci_upper = stats.t.interval(1 - alpha, df, loc=meand_data, scale=se)
        jsonValue = {
            "var_name": VariableID,
            "n": n,
            "df_value": df_value,
            "meand_data": meand_data,
            "sample_std": sample_std,
            "se": se,
            "t": t[0],
            "p": '{:.5f}'.format(pvalue[0]),
            "CI95": [ci_lower, ci_upper]
        }
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 配对样本T检验
def mongo_Ttest_PairedSamples_logic(dataSetId, xVariableID, yVariableID, versionNum, mongodb_cfg, redis_cfg,
                                    analyProcessId, CasesCondition, varMissing):
    jsonValue = ''
    try:
        variableVarMissing, rowMissingValue, rowMissingValueRange, columnMissingValue, columnMissingValueRange = \
            None, [], [], [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, xVariableID)
        for rowItem in rowMeta:
            if 'varMissing' in rowItem:
                variableVarMissing = json.loads(rowItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        rowMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    rowMissingValue.append(str(variableVarMissing['S_Value']))
                if len(rowMissingValue) > 0:
                    varMissingKey.append(xVariableID)
                    varMissingValue.append({'$nin': rowMissingValue})
                if len(rowMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[xVariableID] = {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                                '$lte': float(rowMissingValueRange[1])}}
                    else:
                        CasesCondition = {xVariableID: {'$not': {'$gte': float(rowMissingValueRange[0]),
                                                                 '$lte': float(rowMissingValueRange[1])}}}
        yVarName = []
        if isinstance(yVariableID, list):
            yVarName = yVariableID
        else:
            yVarName.append(yVariableID)
        for yVarNameItemIndex, yVarNameItem in enumerate(yVarName):
            columnMissingValue.append([])
            columnMissingValueRange.append([])
            columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, yVarNameItem)
            for columnItem in columnMeta:
                if 'varMissing' in columnItem:
                    variableVarMissing = json.loads(columnItem['varMissing'])
                    for valueIndex in range(1, 4):
                        if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValue[yVarNameItemIndex]. \
                                append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                        if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValueRange[yVarNameItemIndex]. \
                                append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                    if 'S_Value' in variableVarMissing.keys():
                        columnMissingValue[yVarNameItemIndex].append(str(variableVarMissing['S_Value']))
                    if len(columnMissingValue[yVarNameItemIndex]) > 0:
                        varMissingKey.append(yVarNameItem)
                        varMissingValue.append({'$nin': columnMissingValue[yVarNameItemIndex]})
                    if len(columnMissingValueRange[yVarNameItemIndex]) > 0:
                        if CasesCondition:
                            CasesCondition[yVarNameItem] = \
                                {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                          '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}
                        else:
                            CasesCondition = \
                                {yVarNameItem: {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                                         '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}}
        tTestObj = mongoLinearRegressionAnalyModel(mongodb_cfg)
        tTestData = tTestObj.showDatas(dataSetId, versionNum, xVariableID, yVariableID, CasesCondition, varMissingKey,
                                       varMissingValue)
        # tTestObj.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        df_dropna = DataFrame(tTestData, dtype=np.float64).dropna()
        df = df_dropna

        paired_samples_statistics = []
        columns = [xVariableID, yVariableID]

        for i in columns:
            paired_samples_statistics_columnData = {}
            n = int(df[i].count())
            mean_data = float(df[i].mean())
            sample_std = float(df[i].std())
            # 标准误差=样本标准差/n的开方
            se = sample_std / np.sqrt(n)

            paired_samples_statistics_columnData["column_name"] = i
            paired_samples_statistics_columnData["N"] = float(n)
            paired_samples_statistics_columnData["Mean"] = mean_data
            paired_samples_statistics_columnData["Std_Deviation"] = sample_std
            paired_samples_statistics_columnData["Std_Error_Mean"] = se

            paired_samples_statistics.append(paired_samples_statistics_columnData)

        # print(paired_samples_statistics)

        paired_samples_correlations = {}

        Correlation, Sig = stats.pearsonr(df[xVariableID], df[yVariableID])
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        paired_samples_correlations["N"] = float(df[columns[0]].count())
        paired_samples_correlations["Correlation"] = Correlation
        paired_samples_correlations["Sig"] = Sig

        # print(paired_samples_correlations)

        paired_samples_test = {}
        t_value, p_value = stats.ttest_rel(df[xVariableID], df[yVariableID])

        paired_samples_test["df"] = float(df[columns[0]].count() - 1)
        paired_samples_test["t_value"] = t_value
        paired_samples_test["p_value"] = '{:.5f}'.format(p_value)
        paired_samples_test["Mean"] = paired_samples_statistics[0]["Mean"] - paired_samples_statistics[1]["Mean"]
        diff = np.array(df[columns[0]].values.tolist()) - np.array(df[columns[1]].values.tolist())
        mean_diff = np.mean(diff)
        paired_samples_test["std_diff"] = np.std(diff, ddof=1)
        paired_samples_test["se_diff"] = paired_samples_test["std_diff"] / np.sqrt(paired_samples_correlations["N"])

        # 计算 95% 置信区间
        alpha = 0.05
        t_df = paired_samples_correlations["N"] - 1
        t_critical = stats.t.ppf(1 - alpha / 2, t_df)
        paired_samples_test["CI95"] = [mean_diff - t_critical * paired_samples_test["se_diff"],
                                       mean_diff + t_critical * paired_samples_test["se_diff"]]

        # print(paired_samples_test)
        jsonValue = {"paired_samples_statistics": paired_samples_statistics,
                "paired_samples_correlations": paired_samples_correlations,
                "paired_samples_test": paired_samples_test,

                }
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<相关分析>----- #
def mongo_CorrelationAnalysis_logic(dataSetId, ColumnIDs, Corr, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                    CasesCondition, varMissing):
    jsonValue = ''
    try:
        ColumnIDs = ColumnIDs.split(",")
        variableVarMissing, columnMissingValue, columnMissingValueRange = None, [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        for yVarNameItemIndex, yVarNameItem in enumerate(ColumnIDs):
            columnMissingValue.append([])
            columnMissingValueRange.append([])
            columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, yVarNameItem)
            for columnItem in columnMeta:
                if 'varMissing' in columnItem:
                    variableVarMissing = json.loads(columnItem['varMissing'])
                    for valueIndex in range(1, 4):
                        if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValue[yVarNameItemIndex]. \
                                append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                        if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValueRange[yVarNameItemIndex]. \
                                append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                    if 'S_Value' in variableVarMissing.keys():
                        columnMissingValue[yVarNameItemIndex].append(str(variableVarMissing['S_Value']))
                    if len(columnMissingValue[yVarNameItemIndex]) > 0:
                        varMissingKey.append(yVarNameItem)
                        varMissingValue.append({'$nin': columnMissingValue[yVarNameItemIndex]})
                    if len(columnMissingValueRange[yVarNameItemIndex]) > 0:
                        if CasesCondition:
                            CasesCondition[yVarNameItem] = \
                                {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                          '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}
                        else:
                            CasesCondition = \
                                {yVarNameItem: {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                                         '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}}
        correlationObj = mongoCorrelationAnalysisModel(mongodb_cfg)
        correlationData = correlationObj.showDatas(dataSetId, versionNum, ColumnIDs, CasesCondition, varMissingKey,
                                                   varMissingValue)
        correlationDataGroup = {}
        for columnIDItem in ColumnIDs:
            correlationDataGroup[columnIDItem] = correlationObj.showDatas(dataSetId, versionNum, columnIDItem,
                                                                         CasesCondition, varMissingKey, varMissingValue)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # correlationObj.close()
        df_dropna = DataFrame(correlationData, dtype=np.float64).dropna()
        df_dropnaGroup = {}
        for columnIDItem in ColumnIDs:
            df_dropnaGroup[columnIDItem] = DataFrame(correlationDataGroup[columnIDItem], dtype=np.float64).dropna()

        # spearman 斯皮尔曼系数
        # kendall 肯德尔系数
        # pearson 皮尔逊系数
        # return pearsonr(df_dropna[xVariable], df_dropna[yVariable])
        # return df_dropna.corr(method=Corr).to_dict()

        jsonValue = dict()
        for i in ColumnIDs:
            subdata = dict()
            for j in ColumnIDs:
                analysis_data = dict()
                '''
                    r : float
                        Pearson's correlation coefficient
                    p-value : float
                        2-tailed p-value
                '''
                if Corr == "pearson":
                    if i == j:
                        r, p_value = pearsonr(df_dropnaGroup[i][i], df_dropnaGroup[i][j])
                    else:
                        r, p_value = pearsonr(df_dropna[i], df_dropna[j])
                elif Corr == "spearman":
                    if i == j:
                        r, p_value = spearmanr(df_dropnaGroup[i][i], df_dropnaGroup[i][j])
                    else:
                        r, p_value = spearmanr(df_dropna[i], df_dropna[j])
                elif Corr == "kendall":
                    if i == j:
                        r, p_value = kendalltau(df_dropnaGroup[i][i], df_dropnaGroup[i][j])
                    else:
                        r, p_value = kendalltau(df_dropna[i], df_dropna[j])
                else:
                    r, p_value = 0.0, 0.0
                analysis_data['r'] = r
                analysis_data['p_value'] = '{:.5f}'.format(p_value)
                if i == j:
                    analysis_data['count'] = int(df_dropnaGroup[i][j].count())
                else:
                    analysis_data['count'] = int(df_dropna[j].count())
                subdata[j] = analysis_data

            jsonValue[i] = subdata
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<二元Logistics回归分析>----- #
def mongo_TwoDimensionalLogisticRegression_logic(dataSetId, RowIDs, ColumnID, versionNum, mongodb_cfg, redis_cfg,
                                                 analyProcessId, CasesCondition, varMissing):
    jsonValue = ''
    try:
        variableVarMissing, rowMissingValue, rowMissingValueRange, columnMissingValue, columnMissingValueRange = \
            None, [], [], [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        xVarName = []
        if isinstance(RowIDs, list):
            xVarName = RowIDs
        else:
            xVarName.append(RowIDs)
        for xVarNameItemIndex, xVarNameItem in enumerate(xVarName):
            rowMissingValue.append([])
            rowMissingValueRange.append([])
            rowMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, xVarNameItem)
            for rowItem in rowMeta:
                if 'varMissing' in rowItem:
                    variableVarMissing = json.loads(rowItem['varMissing'])
                    for valueIndex in range(1, 4):
                        if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                            rowMissingValue[xVarNameItemIndex]. \
                                append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                        if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                            rowMissingValueRange[xVarNameItemIndex]. \
                                append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                    if 'S_Value' in variableVarMissing.keys():
                        rowMissingValue[xVarNameItemIndex].append(str(variableVarMissing['S_Value']))
                    if len(rowMissingValue[xVarNameItemIndex]) > 0:
                        varMissingKey.append(xVarNameItem)
                        varMissingValue.append({'$nin': rowMissingValue[xVarNameItemIndex]})
                    if len(rowMissingValueRange[xVarNameItemIndex]) > 0:
                        if CasesCondition:
                            CasesCondition[xVarNameItem] = \
                                {'$not': {'$gte': float(rowMissingValueRange[xVarNameItemIndex][0]),
                                          '$lte': float(rowMissingValueRange[xVarNameItemIndex][1])}}
                        else:
                            CasesCondition = \
                                {xVarNameItem: {'$not': {'$gte': float(rowMissingValueRange[xVarNameItemIndex][0]),
                                                         '$lte': float(rowMissingValueRange[xVarNameItemIndex][1])}}}
        columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, ColumnID)
        for columnItem in columnMeta:
            if 'varMissing' in columnItem:
                variableVarMissing = json.loads(columnItem['varMissing'])
                for valueIndex in range(1, 4):
                    if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValue.append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                    if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                        columnMissingValueRange.append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                if 'S_Value' in variableVarMissing.keys():
                    columnMissingValue.append(str(variableVarMissing['S_Value']))
                if len(columnMissingValue) > 0:
                    varMissingKey.append(ColumnID)
                    varMissingValue.append({'$nin': columnMissingValue})
                if len(columnMissingValueRange) > 0:
                    if CasesCondition:
                        CasesCondition[ColumnID] = {'$not': {'$gte': float(columnMissingValueRange[0]),
                                                             '$lte': float(columnMissingValueRange[1])}}
                    else:
                        CasesCondition = {ColumnID: {'$not': {'$gte': float(columnMissingValueRange[0]),
                                                              '$lte': float(columnMissingValueRange[1])}}}

        # 取数和过滤
        two_obj = mongoTwoDimensionalLogisticRegressionAnalyModel(mongodb_cfg)
        twoData = two_obj.showDatas(dataSetId, versionNum, RowIDs, ColumnID, CasesCondition, varMissingKey,
                                    varMissingValue)
        # two_obj.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        df_dropna = DataFrame(twoData, dtype=np.float64).dropna()
        if df_dropna.empty == True: return ("no data or data error")

        df_X = DataFrame()
        df_Y = DataFrame()  # 因变量，0， 1

        df_X[RowIDs] = df_dropna[RowIDs].values  # 自变量
        df_Y[ColumnID] = df_dropna[ColumnID].values  # 因变量，一般是2个选项

        df_X["intercept"] = 1.0  # 截距项，很重要的呦，我就错在这里了

        YColumnList = list(df_Y[ColumnID].values)
        setYColumnList = list(set(YColumnList))  # 给出数据种类

        # 把因变量的选项规格化为0或1
        if len(setYColumnList) > 2 or len(setYColumnList) < 2:
            raise MyCustomError(retcode=4015)
        # else:
        if len(setYColumnList) == 2 and [0, 1] != [int(i) for i in setYColumnList]:
            newYcolumnsList = []
            for i in YColumnList:
                if i == setYColumnList[0]:
                    newYcolumnsList.append(0)
                else:
                    newYcolumnsList.append(1)
            df_Y = DataFrame({ColumnID: newYcolumnsList})

        logit = sm.Logit(df_Y, df_X)
        res = logit.fit()  # maxiter=10
        res_all = res.summary()

        if isinstance(RowIDs, str) or len(RowIDs) == 1:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            LogLikelihood = [i.strip() for i in str(res_all).split("\n")[6].split("   ") if i][3]
            # 没找到具体参数， 只能这么分割
            index_var = [i.strip() for i in str(res_all).split("\n")[12].split("   ") if i]
            # print(index_var)

            intercept = [i.strip() for i in str(res_all).split("\n")[13].split("   ") if i]
            # print(intercept)
            std_err = [index_var[2], intercept[2]]
            z = [index_var[3], intercept[3]]
            Wald = [res.tvalues[0] * res.tvalues[0], res.tvalues[1] * res.tvalues[1]]
            df_m = [res.df_model, res.df_model]
            P_z = [index_var[4], intercept[4]]  # 显著性
            interval_25 = [index_var[5], intercept[5]]
            interval_975 = [index_var[6], intercept[6]]
            Odds_Ratio = [math.e ** i for i in list(res.params)]
            try:
                Exp_interval_25 = math.exp(float(index_var[5]))
            except OverflowError:
                Exp_interval_25 = float('inf')
            try:
                Exp_interval_975 = math.exp(float(index_var[6]))
            except OverflowError:
                Exp_interval_975 = float('inf')

            jsonValue = {
                "No_Observations": res.nobs,  # No. Observations
                "Pseudo_R": res.prsquared,  # Pseudo R^2
                "Log_Likelihood对数似然": res.llf,  # LogLikelihood
                "-2对数似然": res.llf * -2,
                "LLNull": res.llnull,
                "llr_pvalue": res.llr_pvalue,  # ｌｌｒ显著性
                "coef(B)": list(res.params),  # 系数
                "std_err": std_err,
                "z": z,
                "Wald瓦尔德": Wald,
                "自由度": df_m,
                "P显著性": P_z,  # 显著性
                "interval_25": interval_25,  # 区间0.025，置信区间95%
                "interval_975": interval_975,
                "Exp(B)": Odds_Ratio,
                "Exp(B)_interval_25": Exp_interval_25,  # "Exp(B)置信区间95%
                "Exp(B)_interval_975": Exp_interval_975
            }
        else:
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            LogLikelihood = [i.strip() for i in str(res_all).split("\n")[6].split("   ") if i][3]
            # 没找到具体参数， 只能这么分割
            x_index = 12
            std_err = list()
            z = list()
            Wald = list()
            df_m = list()
            P_z = list()  # 显著性
            interval_25 = list()
            interval_975 = list()
            Exp_interval_25 = list()
            Exp_interval_975 = list()
            for i in range(x_index, x_index + len(RowIDs) + 1):
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                index_var = [i.strip() for i in str(res_all).split("\n")[i].split("   ") if i]
                std_err.append(index_var[2])
                z.append(index_var[3])
                P_z.append(index_var[4])  # 显著性
                interval_25.append(index_var[5])
                interval_975.append(index_var[6])
                try:
                    Exp_interval_25.append(math.exp(float(index_var[5])))
                except OverflowError:
                    Exp_interval_25.append(math.exp(float('inf')))
                try:
                    Exp_interval_975.append(math.exp(float(index_var[6])))
                except OverflowError:
                    Exp_interval_975.append(math.exp(float('inf')))
            for i in range(0, len(RowIDs) + 1):
                if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
                Wald.append(res.tvalues[i] * res.tvalues[i])
                df_m.append(res.df_model)
            Odds_Ratio = [math.e ** i for i in list(res.params)]
            jsonValue = {
                "No_Observations": res.nobs,  # No. Observations
                "Pseudo_R": res.prsquared,  # Pseudo R^2
                "Log_Likelihood对数似然": res.llf,  # LogLikelihood
                "-2对数似然": res.llf * -2,
                "LLNull": res.llnull,
                "llr_pvalue": res.llr_pvalue,  # ｌｌｒ显著性
                "coef(B)": list(res.params),  # 系数
                "std_err": std_err,
                "z": z,
                "Wald瓦尔德": Wald,
                "自由度": df_m,
                "P显著性": P_z,  # 显著性
                "interval_25": interval_25,  # 区间0.025
                "interval_975": interval_975,
                "Exp(B)": Odds_Ratio,
                "Exp(B)_interval_25": Exp_interval_25[: len(RowIDs)],  # "Exp(B)置信区间95%
                "Exp(B)_interval_975": Exp_interval_975[: len(RowIDs)]
            }
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<词频分析>----- #
def mongo_WordFrequency_logic(dataSetId, ColumnIDs, versionNum, mongodb_cfg, redis_cfg, analyProcessId, CasesCondition,
                              removeWord, addWord, imageFlag, varMissing):
    jsonValue = dict(head=[], detailValid=[], detailInvalid=[])
    try:
        ColumnIDs = ColumnIDs.split(",")
        variableVarMissing, columnMissingValue, columnMissingValueRange = None, [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        for yVarNameItemIndex, yVarNameItem in enumerate(ColumnIDs):
            columnMissingValue.append([])
            columnMissingValueRange.append([])
            columnMeta = retMeta.SelectMetaVariable(dataSetId, versionNum, yVarNameItem)
            for columnItem in columnMeta:
                if 'varMissing' in columnItem:
                    variableVarMissing = json.loads(columnItem['varMissing'])
                    for valueIndex in range(1, 4):
                        if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValue[yVarNameItemIndex]. \
                                append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                        if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValueRange[yVarNameItemIndex]. \
                                append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                    if 'S_Value' in variableVarMissing.keys():
                        columnMissingValue[yVarNameItemIndex].append(str(variableVarMissing['S_Value']))
                    if len(columnMissingValue[yVarNameItemIndex]) > 0:
                        varMissingKey.append(yVarNameItem)
                        varMissingValue.append({'$nin': columnMissingValue[yVarNameItemIndex]})
                    if len(columnMissingValueRange[yVarNameItemIndex]) > 0:
                        if CasesCondition:
                            CasesCondition[yVarNameItem] = \
                                {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                          '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}
                        else:
                            CasesCondition = \
                                {yVarNameItem: {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                                         '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}}
        wordFreObj = mongoCorrelationAnalysisModel(mongodb_cfg)
        wordData = wordFreObj.showDatas(dataSetId, versionNum, ColumnIDs, CasesCondition, varMissingKey, varMissingValue)
        # wordFreObj.close()
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        wordDataList, seg_list_exact = [], []
        nltk.data.path.append(r'path_to_nltk_data')  # 替换为nltk数据所在的路径
        remove_words = set(stopwords.words('chinese'))  # 获取中文停用词
        if removeWord is not None and isinstance(removeWord, list):
            for removeWordItem in removeWord:
                remove_words.add(removeWordItem)
        if addWord is not None and isinstance(addWord, list):
            for addWordItem in addWord:
                jieba.add_word(addWordItem)
                if addWordItem in remove_words:
                    remove_words.remove(addWordItem)
        for wordDataItem in wordData:
            for ColumnIDsItem in ColumnIDs:
                if ColumnIDsItem in wordDataItem.keys() and wordDataItem[ColumnIDsItem] is not None and\
                        wordDataItem[ColumnIDsItem] not in remove_words:
                    wordDataList.append(str(wordDataItem[ColumnIDsItem]))
        string_data = "".join(wordDataList)

        pattern = re.compile('\t|\n|\.|-|:|;|\)|\(|\?|（|）|\|"|\u3000|,')  # 定义正则表达式匹配模式
        string_data = re.sub(pattern, '', string_data)  # 将符合模式的字符去除
        object_list = []
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        '''
        try:
            #paddle.enable_static()
            # jieba.enable_paddle()  已经停用
            import jieba.posseg as pseg
            seg_list_exact = pseg.cut(string_data, use_paddle=True)  # 精确模式分词
            for word, flag in seg_list_exact:  # 循环读出每个分词
                wordText = re.sub(r'\d+', '', word)
                if flag != 'd' and len(wordText) > 1 and wordText not in remove_words and wordText.strip() != '':  # 1<长度 并且 不在去除词库中
                    object_list.append(wordText)  # 分词追加到列表
        except Exception as e:
            seg_list_exact = jieba.cut_for_search(string_data)
            for word in seg_list_exact:  # 循环读出每个分词
                wordText = re.sub(r'\d+', '', word)
                if len(wordText) > 1 and wordText not in remove_words and wordText.strip() != '':  # 1<长度 并且 不在去除词库中
                    object_list.append(wordText)  # 分词追加到列表
        '''
        try:
            from pyhanlp import HanLP, CustomDictionary
            if addWord is not None and isinstance(addWord, list):
                for addWordItem in addWord:
                    CustomDictionary.add(addWordItem)

            seg_list_exact = HanLP.segment(string_data)
            for word in seg_list_exact:  # 循环读出每个分词
                wordText = re.sub(r'\d+', '', word.word)
                if len(wordText) > 1 and wordText not in remove_words and wordText.strip() != '':  # 1<长度 并且 不在去除词库中
                    object_list.append(wordText)  # 分词追加到列表
        except Exception as e:
            import jieba.posseg as pseg
            seg_list_exact = pseg.cut(string_data, use_paddle=True)  # 精确模式分词
            for word, flag in seg_list_exact:  # 循环读出每个分词
                wordText = re.sub(r'\d+', '', word)
                if flag != 'd' and len(
                        wordText) > 1 and wordText not in remove_words and wordText.strip() != '':  # 1<长度 并且 不在去除词库中
                    object_list.append(wordText)  # 分词追加到列表

        # remove_words = [u'的', u'，', u'和', u'是', u'随着', u'对于', u'对', u'等', u'能', u'都', u'。', u' ', u'、',
        # u'中', u'在', u'了', u'通常', u'如果', u'我们', u'需要']  # 自定义去除词库

        word_counts = collections.Counter(object_list)  # 对分词做词频统计
        word_counts_top10 = word_counts.most_common(200)  # 获取前10最高频的词
        # word_data_list = []
        # for k, v in word_counts_top10:
        #     if len(k) < 6 and len(k) > 1:
        #         word_data_list.append((k, v))
        jsonValue["head"] = word_counts_top10
        if imageFlag:
            if str(os.path.abspath(os.curdir)).find("analy_python_mongo") > 0:
                filePath = os.path.abspath(os.curdir)
            else:
                filePath = os.path.join(os.path.abspath(os.curdir), "analy_python_mongo")
            fileName = '词云图' + MyGuid() + '.png'
            picName = os.path.join(filePath, fileName)
            imageMask, imageColors = None, None
            imagePath = os.path.join(filePath, '词云图.png')
            if os.path.exists(imagePath):
                imageMask = np.array(Image.open(imagePath))
            font_path = os.path.join(filePath, 'simhei.ttf')
            if imageMask is None:
                wc = WordCloud(font_path=font_path, background_color='white', width=450, prefer_horizontal=1,
                               height=260).\
                    generate_from_frequencies(dict(word_counts_top10))
            else:
                wc = WordCloud(font_path=font_path, background_color='white', width=450, mask=imageMask, scale=1,
                               height=260, prefer_horizontal=1). \
                    generate_from_frequencies(dict(word_counts_top10))
            wc.to_file(picName)
            #with Image.open(picName) as image:
            #    image.thumbnail((299, 199))  # 设置图片的新尺寸大小
            #    image.save(picName, quality=50)  # 设置压缩质量
            if os.path.exists(picName):
                with open(picName, 'rb') as file:
                    encoded_string = base64.b64encode(file.read()).decode('utf-8')
                    jsonValue["image"] = encoded_string
                os.remove(picName)
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# 正态性检验
def mongo_NormalityDistribution_logic(dataSetId, VariableID, dataVersion, mongodb_cfg, redis_cfg, analyProcessId,
                                      CasesCondition, varMissing):
    jsonValue = dict(head=[], detailValid=[], detailInvalid=[])
    try:
        ColumnIDs = VariableID.split(",")
        variableVarMissing, columnMissingValue, columnMissingValueRange = None, [], []
        varMissingKey, varMissingValue = [], []
        retMeta = select_meta_variable(mongodb_cfg)
        for yVarNameItemIndex, yVarNameItem in enumerate(ColumnIDs):
            columnMissingValue.append([])
            columnMissingValueRange.append([])
            columnMeta = retMeta.SelectMetaVariable(dataSetId, dataVersion, yVarNameItem)
            for columnItem in columnMeta:
                if 'varMissing' in columnItem:
                    variableVarMissing = json.loads(columnItem['varMissing'])
                    for valueIndex in range(1, 4):
                        if 'D_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValue[yVarNameItemIndex]. \
                                append(str(variableVarMissing['D_Value' + str(valueIndex)]))
                        if 'L_Value' + str(valueIndex) in variableVarMissing.keys():
                            columnMissingValueRange[yVarNameItemIndex]. \
                                append(str(variableVarMissing['L_Value' + str(valueIndex)]))
                    if 'S_Value' in variableVarMissing.keys():
                        columnMissingValue[yVarNameItemIndex].append(str(variableVarMissing['S_Value']))
                    if len(columnMissingValue[yVarNameItemIndex]) > 0:
                        varMissingKey.append(yVarNameItem)
                        varMissingValue.append({'$nin': columnMissingValue[yVarNameItemIndex]})
                    if len(columnMissingValueRange[yVarNameItemIndex]) > 0:
                        if CasesCondition:
                            CasesCondition[yVarNameItem] = \
                                {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                          '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}
                        else:
                            CasesCondition = \
                                {yVarNameItem: {'$not': {'$gte': float(columnMissingValueRange[yVarNameItemIndex][0]),
                                                         '$lte': float(columnMissingValueRange[yVarNameItemIndex][1])}}}
        retMeans = mongoMeansModel(mongodb_cfg)
        DataSum = retMeans.SumMongo(dataSetId, dataVersion, VariableID, CasesCondition, varMissingKey, varMissingValue)
        if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
        # print(DataSum)
        # retMeans.close()
        DataList = []
        for dataItem in DataSum:
            DataList.append(float(dataItem[VariableID]))
        # DataList = pd.DataFrame(DataSum).values.tolist()
        result = []

        if isinstance(DataList, list) and len(DataList) > 0:
            df = len(DataList)
            # Shapiro-Wilk
            # DataList = [0.873, 2.817, 0.121, -0.945, -0.055, -1.436, 0.360, -1.478, -1.637, -1.869]
            stat, p = stats.shapiro(DataList)
            # print("stat为：%f" % stat, "p值为：%f" % p)
            result.append({
                "method": "Shapiro-Wilk",
                "Statistic": stat,
                "Sig": '{:.5f}'.format(p),
                "df": df
            })
            # =================================================
            # normaltest
            # stat, p = normaltest(DataList)
            # # print("stat为：%f" % stat, "p值为：%f" % p)
            # result.append({
            #     "method": "normaltest",
            #     "Statistic": stat,
            #     "Sig": '{:.5f}'.format(p),
            #     "df": df
            # })

            # lilliefors
            stat, p = lilliefors(DataList)
            if analyProcessId is not None and not redis_get(analyProcessId, redis_cfg): return
            # print("stat为：%f" % stat, "p值为：%f" % p)
            result.append({
                "method": "lilliefors",
                "Statistic": stat,
                "Sig": '{:.5f}'.format(p),
                "df": df
            })
            # =================================================
            # Kolmogorov-Test
            stat, p = stats.kstest(DataList, 'norm', mode='approx')
            # print("stat为：%f" % stat, "p值为：%f" % p)
            result.append({
                "method": "Kolmogorov-Test",
                "Statistic": stat,
                "Sig": '{:.5f}'.format(p),
                "df": df
            })
        jsonValue["head"] = result
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue


# -----<LDA主题模型>----- #
def mongo_LDAModel_logic(dataSetId, ColumnIDs, versionNum, mongodb_cfg, redis_cfg, analyProcessId, CasesCondition,
                         varMissing):
    '''
    try:
        ColumnIDs = ColumnIDs.split(",")
        wordFreObj = mongoCorrelationAnalysisModel(mongodb_cfg)
        wordData = wordFreObj.showDatas(dataSetId, versionNum, ColumnIDs, CasesCondition, varMissing)
        # wordFreObj.close()
        wordDataList = []
        for wordDataItem in wordData:
            wordDataList.append(wordDataItem[ColumnIDs[0]])
        string_data = "".join(wordDataList)

        pattern = re.compile('\t|\n|\.|-|:|;|\)|\(|\?|（|）|\|"|\u3000|,')  # 定义正则表达式匹配模式
        string_data = re.sub(pattern, '', string_data)  # 将符合模式的字符去除

        seg_list_exact = jieba.cut(string_data, cut_all=False)  # 精确模式分词
        object_list = []
        nltk.data.path.append(r'path_to_nltk_data')  # 替换为nltk数据所在的路径
        remove_words = set(stopwords.words('chinese'))  # 获取中文停用词
        # remove_words = [u'的', u'，', u'和', u'是', u'随着', u'对于', u'对', u'等', u'能', u'都', u'。', u' ', u'、',
        # u'中', u'在', u'了', u'通常', u'如果', u'我们', u'需要']  # 自定义去除词库

        for word in seg_list_exact:  # 循环读出每个分词
            if word not in remove_words:  # 不在去除词库中
                object_list.append(word)  # 分词追加到列表

        # 构建文档与词汇的映射关系
        dictionary = corpora.Dictionary([object_list])
        corpus = [dictionary.doc2bow(text) for text in [object_list]]

        # 基于训练语料库训练LDA主题模型
        lda_model = LdaModel(corpus=corpus, id2word=dictionary, num_topics=5, passes=20)

        jsonValue = dict(head=[], detailValid=[], lda_model=[])
        jsonValue["lda_model"] = lda_model
    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue
    '''
    return None


# -----<k-mean 文本分析>----- #
def mongo_kmeans_logic(dataSetId, ColumnIDs, versionNum, mongodb_cfg, redis_cfg, analyProcessId, CasesCondition,
                       varMissing):
    '''
    try:
        ColumnIDs = ColumnIDs.split(",")
        wordFreObj = mongoCorrelationAnalysisModel(mongodb_cfg)
        wordData = wordFreObj.showDatas(dataSetId, versionNum, ColumnIDs, CasesCondition, varMissing)
        # wordFreObj.close()
        wordDataList = []
        for wordDataItem in wordData:
            wordDataList.append(wordDataItem[ColumnIDs[0]])

        # 使用TF-IDF向量化文本数据
        vectorizer = TfidfVectorizer()
        X = vectorizer.fit_transform(wordDataList)

        # 使用K均值聚类算法
        kmeans = KMeans(n_clusters=3, random_state=0)
        kmeans.fit(X)

        jsonValue = dict(head=[], detailValid=[], labels=[], cluster_centers=[], inertia=[], n_iter=[])
        jsonValue["labels"] = kmeans.labels_  # 各聚类中心的坐标
        jsonValue["cluster_centers"] = kmeans.cluster_centers_  # 每个点的标签
        jsonValue["inertia"] = kmeans.inertia_  # 所有样本到其最近聚类中心的平方距离总和，可表示聚类效果的好坏
        jsonValue["n_iter"] = kmeans.n_iter_  # 运行的迭代次数

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue
    '''
    return None


# -----<情感分析>----- #
def mongo_sentiment_analysis_logic(dataSetId, VariableID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                   CasesCondition, varMissing):
    '''
    try:
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
        # wordFreObj.close()
        wordDataList = []
        for wordDataItem in DataCount:
            if wordDataItem['_id'] is not None and str(wordDataItem['_id']).strip() != '' and \
                    str(wordDataItem['_id']).strip() != '#NULL!':
                wordDataList.append(wordDataItem['_id'])

        # 加载中文情感分析模型
        sentiment_analyzer = pipeline("sentiment-analysis", model="bert-base-chinese")

        # 进行中文情感分析
        results = [sentiment_analyzer(text) for text in wordDataList]
        jsonValue = dict(head=[], detailValid=[])

        # 打印结果
        for i, result in enumerate(results):
            sentiment = ''
            confidence = 0
            for r in result:
                sentiment = r['label']
                confidence = r['score']
            jsonValue["detailValid"].append(dict(value=i, text=wordDataList[i],
                                                 sentiment=sentiment,
                                                 confidence=confidence))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue
    '''
    return None


# -----<语义网络分析>----- #
def mongo_semantic_network_analysis_logic(dataSetId, VariableID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                          CasesCondition, varMissing):
    '''
    try:
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
        # wordFreObj.close()
        wordDataList = []
        for wordDataItem in DataCount:
            if wordDataItem['_id'] is not None and str(wordDataItem['_id']).strip() != '' and \
                    str(wordDataItem['_id']).strip() != '#NULL!':
                wordDataList.append(wordDataItem['_id'])

        # 加载中文语义网络分析模型
        # stanfordnlp.download('zh')
        nlp = stanfordnlp.Pipeline(lang="zh")
        jsonValue = dict(head=[], detailValid=[])

        for wordIndex, wordData in enumerate(wordDataList):
            document = nlp(wordData)

            # 提取依存关系三元组
            triples = []
            for sentence in document.sentences:
                for word in sentence.words:
                    if word.dependency_relation != 'root':
                        triples.append((word.text, word.dependency_relation, sentence.words[int(word.index) - 1].text))

            jsonValue["detailValid"].append(dict(value=wordIndex, text=wordData, triples=triples))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue
    '''
    return None


# -----<社交网络分析>----- #
def mongo_social_network_analysis_logic(dataSetId, VariableID, versionNum, mongodb_cfg, redis_cfg, analyProcessId,
                                        CasesCondition, varMissing):
    '''
    try:
        retFrequency = mongoFrequencyModel(mongodb_cfg)
        DataCount = retFrequency.CountMongo(dataSetId, versionNum, VariableID, CasesCondition, varMissing)
        # wordFreObj.close()
        wordDataList = []
        for wordDataItem in DataCount:
            if wordDataItem['_id'] is not None and str(wordDataItem['_id']).strip() != '' and \
                    str(wordDataItem['_id']).strip() != '#NULL!':
                wordDataList.append(wordDataItem['_id'])

        # 初始化StanfordNLP中文模型
        nlp = stanfordnlp.Pipeline(lang="zh")

        # 创建空的有向图
        graph = nx.DiGraph()

        # 遍历每个文本
        for wordIndex, wordData in enumerate(wordDataList):
            # 执行语言处理流程
            doc = nlp(wordData)

            # 获取依存句法分析结果
            sentences = doc.sentences
            for sentence in sentences:
                for word in sentence.words:
                    if word.upos == 'NOUN' or word.upos == 'PROPN':  # 只考虑名词和专有名词
                        graph.add_node(word.text)

                        if int(word.index) != 0 and sentence.words[int(word.index) - 1].upos == 'NOUN':
                            source = sentence.words[int(word.index) - 1].text
                            target = word.text
                            graph.add_edge(source, target)

        jsonValue = dict(head=[], detailValid=[])
        jsonValue["head"].append(dict(Nodes=graph.nodes(), Edges=graph.edges()))

    except Exception as e:
        jsonValue = json.dumps({"code": "参数错误", "msg": str(e)})
    finally:
        if analyProcessId is not None:
            redis_update(analyProcessId, jsonValue, redis_cfg)
            return None
        else:
            return jsonValue
    '''
    return None


def is_number(s):
    try:  # 如果能运行float(s)语句，返回True（字符串s是浮点数）
        float(s)
        return True
    except ValueError:  # ValueError为Python的一种标准异常，表示"传入无效的参数"
        pass  # 如果引发了ValueError这种异常，不做任何事情（pass：不做任何事情，一般用做占位语句）
    try:
        import unicodedata  # 处理ASCii码的包
        for n in s:
            unicodedata.numeric(n)  # 把一个表示数字的字符串转换为浮点数返回的函数
            # return True
        return True
    except (TypeError, ValueError):
        pass
    return False


def check_json_format(raw_msg):
    if isinstance(raw_msg, str):
        try:
            json.loads(raw_msg)
            for key, value in json.loads(str(raw_msg).strip()).items():
                return True
        except Exception as e:
            pass
        return False
    else:
        return False


def redis_update(analyProcessId, jsonValue, redis_cfg):
    try:
        if str(redis_cfg['host']).find(',') > -1:
            host_list = str(redis_cfg['host']).split(',')
            port_list = str(redis_cfg['port']).split(',')
            host_port_list = []
            for host_list_index, host_list_item in enumerate(host_list):
                if host_list_index < len(port_list):
                    host_port_list.append((host_list_item, int(port_list[host_list_index])))
                else:
                    host_port_list.append((host_list_item, int(port_list[0])))
            sentinel = Sentinel(host_port_list)
            master = sentinel.master_for(redis_cfg['mymaster'], socket_timeout=1000, password=redis_cfg['password'])
            master.set(redis_cfg['namespace'] + ':' + analyProcessId, json.dumps(jsonValue, ensure_ascii=False), ex=1000)
        else:
            r = redis.Redis(host=redis_cfg['host'], port=redis_cfg['port'], password=redis_cfg['password'],
                            decode_responses=True)
            r.set(redis_cfg['namespace'] + ':' + analyProcessId, json.dumps(jsonValue, ensure_ascii=False), ex=1000)
        print(json.dumps(jsonValue, ensure_ascii=False))
    except Exception as ex:
        print(ex)


def redis_get(analyProcessId, redis_cfg):
    analyStatus = ''
    try:
        if str(redis_cfg['host']).find(',') > -1:
            host_list = str(redis_cfg['host']).split(',')
            port_list = str(redis_cfg['port']).split(',')
            host_port_list = []
            for host_list_index, host_list_item in enumerate(host_list):
                if host_list_index < len(port_list):
                    host_port_list.append((host_list_item, int(port_list[host_list_index])))
                else:
                    host_port_list.append((host_list_item, int(port_list[0])))
            sentinel = Sentinel(host_port_list)
            master = sentinel.master_for(redis_cfg['mymaster'], socket_timeout=1000, password=redis_cfg['password'],
                                         decode_responses=False)
            analyStatus = master.get(redis_cfg['namespace'] + ':' + analyProcessId).decode('utf-8')
        else:
            r = redis.Redis(host=redis_cfg['host'], port=redis_cfg['port'], password=redis_cfg['password'],
                            decode_responses=False)
            analyStatus = r.get(redis_cfg['namespace'] + ':' + analyProcessId).decode('utf-8')
    except Exception as ex:
        print(ex)
    finally:
        if analyStatus is not None and str(analyStatus).strip() == '计算中':
            return True
        else:
            return False


# 卡方
class chiSquareway():
    def __init__(self):
        pass

    @classmethod
    def run(cls, df_dropna, variableOne, variableTwo):
        try:
            setVariableOne = list(set(df_dropna[variableOne]))
            setvariableTwo = list(set(df_dropna[variableTwo]))

            myNewPandasDict = {}

            for i in setVariableOne:
                myNewPandasSubKeyDataDict = {}

                for j in range(len(df_dropna.index)):
                    if i == df_dropna.iloc[j][variableOne]:
                        myNewPandasSubKeyDataDict[df_dropna.iloc[j][variableTwo]] = df_dropna.iloc[j]["count"]

                myNewPandasDict[i] = myNewPandasSubKeyDataDict
            dataCountValueDataFrame = DataFrame(myNewPandasDict).fillna(0)

            floatNi = []  # 行的和
            floatNj = []  # 列的和
            chisq = 0

            for i in dataCountValueDataFrame.index:
                floatNi.append(dataCountValueDataFrame.loc[i].sum())
            for i in dataCountValueDataFrame.columns:
                floatNj.append(dataCountValueDataFrame[i].sum())

            sumTotal = sum(floatNi)

            Eij = []  # 理论频率， 二维数组

            for i in range(len(dataCountValueDataFrame.index)):

                for j in range(len(dataCountValueDataFrame.iloc[i])):
                    subValue = dataCountValueDataFrame.iloc[i].iloc[j]  # 原始值
                    subEij = floatNi[i] * floatNj[j] / sumTotal  # 理论频率
                    subChisqValue = ((subValue - subEij) * (subValue - subEij)) / float(subEij)

                    chisq += subChisqValue

            df = (len(floatNi) - 1) * (len(floatNj) - 1)
            P = stats.chi2.sf(chisq, df)
            if np.isnan(P):
                P = "NAN"

            # df 自由度
            # p 显著性
            # 值 pvalue
            # chisq 卡方
            # p 大写
            ChiSquare2wayValue = {"chisq": chisq, "df": df, "N": int(sumTotal), "P": P}
        except Exception as e:
            ChiSquare2wayValue = {"chisq": "NAN", "df": "NAN", "P": "NAN", "N": "NAN"}

        return ChiSquare2wayValue


if __name__ == '__main__':
    nacos_main(None)
    versionNum = None
    condition = {"isDeleted":{"$ne":True}} #{"$and":[{"$and":[{"转换分数":{"$gt":0}}]},{"$or":[{"$and":[{"$and":[{"学校名称":"上海交通大学"}]}]}]}],"isDeleted":{"$ne":True}}
    dataSetId = "671709a3e5603c36f162a490"  # "664474721d43b8203d8a04fe"
    serverUrl = 'edatalocalpython.zkey.cc'
    mongodb_cfg, maxResponseCount, redis_cfg = nacos_py(serverUrl)
    RowID = "P1Q1A"
    VariableID = "P2Q4S1"
    IntervalRange = ''
    replaceText = []
    dataVersion = 1
    varMissing = {}
    OptionIDRow = ["D4S1", "D4S2", "D4S3", "D4S4", "D4S5", "D4S6", "D4S7"]
    OptionID = ["B6S1","B6S2","B6S3"]
    analyProcessId = None
    result_data = mongo_comparemeans_logic(dataSetId, RowID, VariableID, IntervalRange, dataVersion, mongodb_cfg,
                                           redis_cfg, analyProcessId, condition, varMissing, replaceText)

    #result_data = mongo_comparemeans2_logic(dataSetId, RowID, VariableID, dataVersion, mongodb_cfg,
    #                                        redis_cfg, analyProcessId, condition)

    #result_data = mongo_WordFrequency_logic(dataSetId, VariableID, dataVersion, mongodb_cfg,
    #                                       redis_cfg, analyProcessId, condition, ['北京', '上海'], ['临床医学', '工商管理', '工程管理'], True, varMissing)

    #result_data = mongo_crosstabs_logic(dataSetId, RowID, VariableID, None, dataVersion, mongodb_cfg,
    #                                        redis_cfg, analyProcessId, condition, varMissing)

    #result_data = mongo_means_logic(dataSetId, VariableID, None, "", dataVersion, mongodb_cfg,
    #                                    redis_cfg, analyProcessId, condition, varMissing, None)

    #result_data = mongo_means2_logic(dataSetId, VariableID, "", dataVersion, mongodb_cfg,
    #                                    redis_cfg, analyProcessId, condition)

    #result_data = mongo_multiple_logic(dataSetId, VariableID, "1", dataVersion, mongodb_cfg,
    #                                redis_cfg, analyProcessId, condition, varMissing)

    #result_data = mongo_LinearRegressionDetail_logic(dataSetId, RowID, VariableID, dataVersion, mongodb_cfg,
    #                                    redis_cfg, analyProcessId, condition, varMissing)

    #result_data = mongo_Ttest_indResultDetail_logic(dataSetId, RowID, VariableID, 1, 2, dataVersion, mongodb_cfg,
    #                                                redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_Ttest_PairedSamples_logic(dataSetId, RowID, VariableID, dataVersion, mongodb_cfg,
    #                                                redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_NormalityDistribution_logic(dataSetId, VariableID, dataVersion, mongodb_cfg,
    #                                                redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_Ttest_SingleSample_logic(dataSetId, VariableID, dataVersion, mongodb_cfg,
    #                                                redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_CorrelationAnalysis_logic(dataSetId, VariableID, 'spearman', dataVersion, mongodb_cfg,
    #                                                redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_TwoDimensionalLogisticRegression_logic(dataSetId, RowID, VariableID,dataVersion, mongodb_cfg,
    #                                                            redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_crosstabsMultiple_logic(dataSetId, RowID, VariableID, '1', dataVersion, mongodb_cfg,
    #                                        redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_multiple2_logic(dataSetId, '1', OptionID, dataVersion, mongodb_cfg,
    #                                        redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_crosstabsMultiple2_logic(dataSetId, RowID, '1', OptionID, dataVersion, mongodb_cfg,
    #                                        redis_cfg, analyProcessId, condition, varMissing)
    #result_data = mongo_crosstabsMultipleTypeResponse_logic(dataSetId, RowID, OptionID, '0', '1', dataVersion, mongodb_cfg,
    #                                             redis_cfg, analyProcessId, condition, varMissing)

    #result_data = mongo_multipleAndMultipleCross_logic(dataSetId, '1', OptionIDRow, '1', OptionID, dataVersion,
    #                                                   mongodb_cfg, redis_cfg, analyProcessId, condition, varMissing)

    #result_data = mongo_multipleAndSingleCross_logic(dataSetId, '1', OptionIDRow, VariableID, dataVersion,
    #                                                   mongodb_cfg, redis_cfg, analyProcessId, condition, varMissing)
    resp = json.dumps(result_data)
    print(result_data)
