#!/usr/bin/env python
# -*- coding:utf-8 -*-

from mongoengine import *
import copy
from common.base import *


class data_case(DynamicDocument):
    # ID=StringField(required=True,max_length=100)
    # platId=StringField(required=True,max_length=100)
    # projId=StringField(required=True,max_length=100)
    dataSetId = StringField(required=True, max_length=100)
    dataVersion = IntField(required=True)


# 根据问卷id查询变量
class select_meta_variable():
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def SelectMetaVariable(self, dataSetId, version, VariableID):
        self.res.connect_db()
        pipeline = [
            {"$match": {"dataSetId": dataSetId}}
        ]
        if VariableID:
            pipeline = [
                {"$match": {"dataSetId": dataSetId, "varName": VariableID}}
            ]
        # if version and version is not None:
        #     ret = meta_variable.objects(dataSetId=dataSetId, dataVersion=version).aggregate(
        #         *pipeline)
        # else:
        ret = meta_questionnaire_varial.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def close(self):
        self.res.disconnect()


class meta_variable(DynamicDocument):
    platId = StringField(required=True, max_length=100)
    projId = StringField(required=True, max_length=100)
    dataSetId = StringField(required=True, max_length=100)


class meta_questionnaire_varial(DynamicDocument):
    projId=StringField(required=True,max_length=100)
    dataSetId=StringField(required=True,max_length=100)


class mongoTemplateModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def SelectTemplate(self, PlatID, ProjID, TempID):
        self.res.connect_db()
        pipeline = [
            {"$match": {"platId": PlatID, "projId": ProjID, "tempId": TempID}}
        ]
        # ret = client._get_collection("report_template").aggregate(*pipeline)
        retTemp = report_template.objects(platId=PlatID, projId=ProjID, tempId=TempID).aggregate(*pipeline)
        return retTemp

    def close(self):
        self.res.disconnect()


class report_template(DynamicDocument):
    platId = StringField(required=True, max_length=100)
    projId = StringField(required=True, max_length=100)
    tempId = StringField(required=True, max_length=100)


# class dataversion:
#     def __init__(self, mongodb_cfg):# libname="readInfo"
#         self.libname = mongodb_cfg
#         self.res = Pymongoengine(self.libname)
#
#     def version(self,dataSetId):
#         self.res.connect_db()
#         print(self.res.connect_db())
#         pipeline=[
#             {"$group": {"_id":0,"version": {"$max":"$dataVersion"}}}
#         ]
#         ret=data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
#         print(ret)
#         return ret
#     def close(self):
#         self.res.disconnect()


# -----<频次分析>----- #
# noinspection PyProtectedMember
class mongoFrequencyModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def CountMongo(self, dataSetId, version, VariableID, CasesCondition, varMissing):
        self.res.connect_db()
        if CasesCondition is None:
            pipeline = [
                {"$match": {"dataSetId": dataSetId}},
                {"$group": {"_id": "$" + VariableID, "count": {"$sum": 1}}},
                {"$sort": {VariableID: 1}}
            ]
        else:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, project, projectToNum, matchKeys, matchValues, groupKeys, groupValues = conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + project[projectOldIndex] + '"', 1)

            project.append(VariableID),projectToNum.append(1)
            matchKeys.append("dataSetId"), matchValues.append(dataSetId)
            CasesCondition = json.loads(CasesConditionStr)
            matchs = dict(zip(matchKeys, matchValues))
            pipeline = [
                {"$match": matchs}, {"$project": dict(zip(project, projectToNum))},
                {"$match": CasesCondition},
                {"$group": {"_id": "$" + VariableID, "count": {"$sum": 1}}},
                {"$sort": {VariableID: 1}}
            ]
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        # print(ret)
        return ret

    def close(self):
        self.res.disconnect()


# class mongo_variable():
#     def __init__(self, mongodb_cfg): #libname="readInfo"
#         self.libname = mongodb_cfg
#         self.res = Pymongoengine(self.libname)
#
#     def SelectVariable (self,dataSetId,VariableID,version,CasesCondition,varMissing):
#         self.res.connect_db()
#         pipeline = [
#             {"$match":{"dataSetId": dataSetId, VariableID:{"$ne":""}}},
#             {"$project":{"_id":0,VariableID:0}}
#         ]
#         if CasesCondition:
#             keys = [VariableID]
#             values = [{"$ne":""}]
#             for key, value in CasesCondition.items():
#                 keys.append(key)
#                 values.append(value)
#             conditioncase = json.dumps(dict(zip(keys, values)))
#             pipeline = [
#                 {"$match":json.loads(conditioncase)},
#                 {"$project":{"_id":0, VariableID:0}}
#             ]
#         if version and version is not None:
#             ret = meta_variable.objects(dataSetId=dataSetId, dataVersion=version).aggregate(
#                 *pipeline)
#         else:
#             ret = meta_variable.objects(dataSetId=dataSetId).aggregate(*pipeline)
#         return ret
#     def close(self):
#         self.res.disconnect()

# -----<均值>----- #
class mongoMeansModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def SumMongo(self, dataSetId, version, VariableID, CasesCondition, varMissingKey, varMissingValue):
        self.res.connect_db()
        if CasesCondition is None:
            pipeline = [
                {"$match": {"dataSetId": dataSetId, VariableID: {"$ne": ""}}},
                {"$project": {"_id": 0, VariableID: 1}}
            ]
        else:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, project, projectToNum, matchKeys, matchValues, groupKeys, groupValues = \
                conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + project[projectOldIndex] + '"', 1)
            project.append("_id"), project.append(VariableID)
            projectToNum.append(0), projectToNum.append(1)
            matchKeys.append(VariableID)
            if VariableID in varMissingKey:
                for missingKey, missingValue in varMissingValue[varMissingKey.index(VariableID)].items():
                    if missingKey == '$nin':
                        varMissingValue[varMissingKey.index(VariableID)][missingKey].extend(["", "None"])
                matchValues.append(varMissingValue[varMissingKey.index(VariableID)])
            else:
                matchValues.append({"$nin": ["", "None"]})
            CasesCondition = json.loads(CasesConditionStr)
            matchs = dict(zip(matchKeys, matchValues))
            pipeline = [
                {"$match": matchs}, {"$project": dict(zip(project, projectToNum))},
                {"$match": CasesCondition}, {"$project": {"_id": 0, VariableID: 1}}
            ]
        # if version and version is not None:
        #     sortData = data_case.objects(dataSetId=dataSetId, dataVersion=version).aggregate(*pipeline)
        # else:
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            sortData = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            sortData = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)

        # print(type(sortData))
        # print(sortData)
        # print(list(sortData))
        sortData1 = []
        for i in sortData:
            if VariableID in i:  # 判断变量是否在查到的数据中
                if not isinstance(i[VariableID], str):
                    i[VariableID] = str(i[VariableID])
                sortData1.append(i)
        # print(sortData1)

        return sortData1

    def SumMongoAvg (self,dataSetId,version,VariableID, CasesCondition, varMissingKey, varMissingValue):
        self.res.connect_db()
        projectKeys, projectValues, groupKeys, groupValues, totalValues, nowString, matchKeys, matchValues,\
        totalValuesItem, count =  \
            ['_id'], [0], ["_id"], ["null"], [], datetime.datetime.now().strftime('%H%M%S%f'), [], [], [], 1
        matchKeys.append(VariableID)
        if VariableID in varMissingKey:
            for missingKey, missingValue in varMissingValue[varMissingKey.index(VariableID)].items():
                if missingKey == '$nin':
                    varMissingValue[varMissingKey.index(VariableID)][missingKey].extend(["", "None", "null"])
            matchValues.append(varMissingValue[varMissingKey.index(VariableID)])
        else:
            matchValues.append({"$nin": ["", "None", "null"]})
        totalValues.append({"$toDouble": "$" + VariableID})
        projectKeys.append(VariableID + nowString)
        projectValues.append({"$add": totalValues})
        groupKeys.append("count" )
        groupValues.append({"$sum": count})
        groupKeys.append(VariableID + "avg")
        groupValues.append({"$avg" : "$" + VariableID + nowString})
        groupKeys.append(VariableID + "sum")
        groupValues.append({"$sum": "$" + VariableID + nowString})
        groupKeys.append(VariableID + "min")
        groupValues.append({"$min": "$" + VariableID + nowString})
        groupKeys.append(VariableID + "max")
        groupValues.append({"$max": "$" + VariableID + nowString})
        projects = dict(zip(projectKeys, projectValues))
        groups = dict(zip(groupKeys, groupValues))
        matchs = dict(zip(matchKeys, matchValues))
        pipeline = [{"$match": matchs}, {"$project": projects}, {"$group": groups}]
        if CasesCondition is not None:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, projectKeys2, projectValues2, matchKeys2, matchValues2, groupKeys2, groupValues2 = \
                conditionReset(conditionGroup)
            projectKeys.extend(projectKeys2)
            projectValues.extend(projectValues2)
            matchKeys.extend(matchKeys2)
            matchValues.extend(matchValues2)
            groupKeys.extend(groupKeys2)
            groupValues.extend(groupValues2)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + projectKeys2[projectOldIndex] + '"', 1)
            conditioncase = json.loads(CasesConditionStr)
            projects = dict(zip(projectKeys, projectValues))
            groups = dict(zip(groupKeys, groupValues))
            matchs = dict(zip(matchKeys, matchValues))
            pipeline = [{"$match": matchs}, {"$project": projects},{"$match": conditioncase}, {"$group": groups}]
        dataSetIdSave = dataSetId
        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)
        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            sortData = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            sortData = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)

        return sortData

    def close(self):
        self.res.disconnect()


# -----<列联表分析>----- #
class mongoCrosstabsModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def CrosstabsCountMongo(self, dataSetId, version, rowID, columnID, CasesCondition, varMissing):
        self.res.connect_db()

        groupKeys, sortKeys = {rowID: "$" + rowID}, {rowID: 1}
        conditionGroup = []
        for keyCondition, valueCondition in CasesCondition.items():
            if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                for valueConditionItem in valueCondition:
                    if isinstance(valueConditionItem, dict):
                        if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                or '$or' in valueConditionItem.keys():
                            for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                conditionGroup.append(valueValueConditionItem)
                        else:
                            conditionGroup.append(valueConditionItem)
            else:
                conditionGroup.append({keyCondition: valueCondition})
        projectOld, projectKeys, projectValues, mkeys, mvalues, groupKeys2, groupValues2 = conditionReset(conditionGroup)
        CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
        for projectOldIndex, projectOldItem in enumerate(projectOld):
            CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                          '"' + projectKeys[projectOldIndex] + '"', 1)
        mkeys.append(rowID), projectKeys.append(rowID)
        mvalues.append({"$nin": ["", "None"]}), projectValues.append(1)
        mkeys.append(columnID), projectKeys.append(columnID)
        mvalues.append({"$nin": ["", "None"]}), projectValues.append(1)
        groupKeys[columnID] = "$" + columnID
        sortKeys[columnID] = 1
        CasesCondition = json.loads(CasesConditionStr)
        matchs = dict(zip(mkeys, mvalues))
        projects = dict(zip(projectKeys, projectValues))
        pipeline = [
            {"$match": matchs}, {"$project": projects}, {"$match": CasesCondition},
            {"$group": {"_id": groupKeys, "count": {"$sum": 1}}},
            {"$sort": sortKeys}
        ]

        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId,dataVersion=version).aggregate(*pipeline)
        # else:
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)

        # print(ret)
        return ret

    def close(self):
        self.res.disconnect()


# -----<比较均值>----- #
class mongoCompareMeansModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def CompareSumMongo(self, dataSetId, version, rowID, columnID, CasesCondition, varMissing):
        self.res.connect_db()
        conditionGroup = []
        for keyCondition, valueCondition in CasesCondition.items():
            if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                for valueConditionItem in valueCondition:
                    if isinstance(valueConditionItem, dict):
                        if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                or '$or' in valueConditionItem.keys():
                            for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                conditionGroup.append(valueValueConditionItem)
                        else:
                            conditionGroup.append(valueConditionItem)
            else:
                conditionGroup.append({keyCondition: valueCondition})
        projectOld, projectKeys, projectValues, mkeys, mvalues, groupKeys, groupValues = conditionReset(conditionGroup)
        CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
        for projectOldIndex, projectOldItem in enumerate(projectOld):
            CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                          '"' + projectKeys[projectOldIndex] + '"', 1)
        mkeys.append(rowID), projectKeys.append(rowID)
        mvalues.append({"$nin": ["", "None"]}), projectValues.append(1)
        mkeys.append(columnID), projectKeys.append(columnID)
        mvalues.append({"$nin": ["", "None"]}), projectValues.append(1)
        CasesCondition = json.loads(CasesConditionStr)
        matchs = dict(zip(mkeys, mvalues))
        projects = dict(zip(projectKeys, projectValues))
        pipeline = [{"$match": matchs}, {"$project": projects}, {"$match": CasesCondition},
                    {"$group": {"_id": {rowID: "$" + rowID, columnID: "$" + columnID}, "count": {"$sum": 1}}},
                    {"$sort": {rowID: 1, columnID: 1}}]
        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId, dataVersion=version).aggregate(*pipeline)
        # else:
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def sortDataMongo(self, dataSetId, version, rowID, columnID, optionID, CasesCondition, varMissing):
        self.res.connect_db()
        projectKeys, projectValues, matchKeys, matchValues = \
            ['_id', columnID], [0, 1], [rowID, columnID], [optionID, {"$nin": ["", "None"]}]
        projects2 = dict(zip(projectKeys, projectValues))
        projectKeys.append(rowID), projectValues.append(1)
        projects = dict(zip(projectKeys, projectValues))
        matchs = dict(zip(matchKeys, matchValues))
        pipeline = [{"$match": matchs}, {"$project": projects}]

        if CasesCondition:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, projectKeys, projectValues, mkeys, mvalues, groupKeys, groupValues = conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + projectKeys[projectOldIndex] + '"', 1)
            mkeys.append(rowID), mkeys.append(columnID)
            mvalues.append(optionID), mvalues.append({"$nin": ["", "None"]})
            projectKeys.append('_id'), projectKeys.append(rowID), projectKeys.append(columnID)
            projectValues.append(0), projectValues.append(1), projectValues.append(1)
            CasesCondition = json.loads(CasesConditionStr)
            matchs = dict(zip(mkeys, mvalues))
            projects = dict(zip(projectKeys, projectValues))
            pipeline = [{"$match": matchs}, {"$project": projects}, {"$match": CasesCondition}, {"$project": projects2}]

        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId, dataVersion=version).aggregate(*pipeline)
        # else:
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def SumMongoCompareAvg(self, dataSetId, version, rowID, columnID, CasesCondition, varMissingKey, varMissingValue):
        self.res.connect_db()
        projectKeys, projectValues, groupKeys, totalValues, nowString, matchKeys, matchValues, totalValuesItem = \
            ['_id'], [0], ["_id"], [], datetime.datetime.now().strftime('%H%M%S%f'), [], [], []
        projectKeysVariable, conditioncase, count = "", None, 1
        if isinstance(rowID, list):
            groupValues = [{rowID[0]: "$" + rowID[0]}]
        else:
            groupValues = [{rowID: "$" + rowID}]
        projectKeysVariable = columnID
        if rowID in varMissingKey:
            matchKeys.append(rowID)
            matchValues.append(varMissingValue[varMissingKey.index(rowID)])
        matchKeys.append(columnID)
        if columnID in varMissingKey:
            for missingKey, missingValue in varMissingValue[varMissingKey.index(columnID)].items():
                if missingKey == '$nin':
                    varMissingValue[varMissingKey.index(columnID)][missingKey].extend(["", "None", "null", None])
            matchValues.append(varMissingValue[varMissingKey.index(columnID)])
        else:
            matchValues.append({"$nin": ["", "None", "null", None]})
        totalValues.append({"$toDouble": "$" + columnID})
        projectKeys.append(rowID)
        projectValues.append(1)
        projectKeys.append(projectKeysVariable + nowString)
        projectValues.append({"$add": totalValues})
        groupKeys.append("count")
        groupValues.append({"$sum": count})
        groupKeys.append(projectKeysVariable + "avg")
        groupValues.append({"$avg": "$" + projectKeysVariable + nowString})
        groupKeys.append(projectKeysVariable + "sum")
        groupValues.append({"$sum": "$" + projectKeysVariable + nowString})
        groupKeys.append(projectKeysVariable + "min")
        groupValues.append({"$min": "$" + projectKeysVariable + nowString})
        groupKeys.append(projectKeysVariable + "max")
        groupValues.append({"$max": "$" + projectKeysVariable + nowString})
        if CasesCondition:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, projectKeys2, projectValues2, matchKeys2, matchValues2, groupKeys2, groupValues2 = \
                conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + projectKeys[projectOldIndex] + '"', 1)
            projectKeys.extend(projectKeys2)
            projectValues.extend(projectValues2)
            matchKeys.extend(matchKeys2)
            matchValues.extend(matchValues2)
            groupKeys.extend(groupKeys2)
            groupValues.extend(groupValues2)
            conditioncase = json.loads(CasesConditionStr)
        projects = dict(zip(projectKeys, projectValues))
        groups = dict(zip(groupKeys, groupValues))
        matchs = dict(zip(matchKeys, matchValues))
        if conditioncase is None:
            pipeline = [{"$match": matchs}, {"$project": projects}, {"$group": groups}]
        else:
            pipeline = [{"$match": matchs}, {"$project": projects}, {"$match": conditioncase}, {"$group": groups}]
        dataSetIdSave = dataSetId
        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def close(self):
        self.res.disconnect()


# -----<列联表分析>----- #排序
class mongoSortModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def SortMongo(self, dataSetId, version, VariableID1, VariableID2, VariableID3, CasesCondition, varMissing):
        self.res.connect_db()

        pipeline = [
            {"$match": {"dataSetId": dataSetId}},
            {"$group": {"_id": {VariableID1: "$" + VariableID1, VariableID2: "$" + VariableID2,
                                VariableID3: "$" + VariableID3}, "count": {"$sum": 1}}},
            {"$sort": {VariableID1: 1}}
        ]
        if CasesCondition:
            keys = []
            values = []
            for key, value in CasesCondition.items():
                keys.append(key)
                values.append(value)
            conditioncase = json.dumps(dict(zip(keys, values)))
            pipeline = [
                {"$match": json.loads(conditioncase)},
                {"$group": {"_id": {VariableID1: "$" + VariableID1, VariableID2: "$" + VariableID2,
                                    VariableID3: "$" + VariableID3}, "count": {"$sum": 1}}},
                {"$sort": {VariableID1: 1}}
            ]
        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId,dataVersion=version).aggregate(*pipeline)
        # else:
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        # print(ret)
        return ret

    def close(self):
        self.res.disconnect()


#
# -----<线性回归>----- #
class mongoLinearRegressionAnalyModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def showDatas(self, dataSetId, version, xVariableID, yVariableID, CasesCondition, varMissingKey, varMissingValue):
        self.res.connect_db()
        projectKeys, projectValues, projectKeys2, projectValues2, mkeys, mvalues = [], [], [], [], [], []
        if CasesCondition:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, projectKeys, projectValues, mkeys, mvalues, groupKeys, groupValues = conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + projectKeys[projectOldIndex] + '"', 1)
            CasesCondition = json.loads(CasesConditionStr)
        projectKeys.append('_id'), projectKeys.append(xVariableID)
        projectValues.append(0), projectValues.append(1)
        projectKeys2.append('_id'), projectKeys2.append(xVariableID)
        projectValues2.append(0), projectValues2.append(1)
        mkeys.append(xVariableID)
        if xVariableID in varMissingKey:
            for missingKey, missingValue in varMissingValue[varMissingKey.index(xVariableID)].items():
                if missingKey == '$nin':
                    varMissingValue[varMissingKey.index(xVariableID)][missingKey].extend(["", "None"])
            mvalues.append(varMissingValue[varMissingKey.index(xVariableID)])
        else:
            mvalues.append({"$nin": ["", "None"]})
        if isinstance(yVariableID, list):
            for variableItem in yVariableID:
                projectKeys.append(variableItem)
                projectValues.append(1)
                projectKeys2.append(variableItem)
                projectValues2.append(1)
                mkeys.append(variableItem)
                if variableItem in varMissingKey:
                    for missingKey, missingValue in varMissingValue[varMissingKey.index(variableItem)].items():
                        if missingKey == '$nin':
                            varMissingValue[varMissingKey.index(variableItem)][missingKey].extend(["", "None"])
                    mvalues.append(varMissingValue[varMissingKey.index(variableItem)])
                else:
                    mvalues.append({"$nin": ["", "None"]})
        else:
            projectKeys.append(yVariableID)
            projectValues.append(1)
            projectKeys2.append(yVariableID)
            projectValues2.append(1)
            mkeys.append(yVariableID)
            if yVariableID in varMissingKey:
                for missingKey, missingValue in varMissingValue[varMissingKey.index(yVariableID)].items():
                    if missingKey == '$nin':
                        varMissingValue[varMissingKey.index(yVariableID)][missingKey].extend(["", "None"])
                mvalues.append(varMissingValue[varMissingKey.index(yVariableID)])
            else:
                mvalues.append({"$nin": ["", "None"]})
        matchs = json.dumps(dict(zip(mkeys, mvalues)))
        pipeline = [{"$match": json.loads(matchs)}]
        projects = json.dumps(dict(zip(projectKeys, projectValues)))
        pipeline.append({"$project": json.loads(projects)})
        if CasesCondition:
            pipeline.append({"$match": CasesCondition})
            pipeline.append({"$project": dict(zip(projectKeys2, projectValues2))})
        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId, dataVersion=version).aggregate(*pipeline)
        # else:

        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def close(self):
        self.res.disconnect()


# -----<二元Logistics回归分析>----- #
class mongoTwoDimensionalLogisticRegressionAnalyModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def showDatas(self, dataSetId, version, xVariableIDs, yVariableID, CasesCondition, varMissingKey, varMissingValue):
        self.res.connect_db()
        projectKeys, projectValues, projectKeys2, projectValues2, mkeys, mvalues = [], [], [], [], [], []
        if CasesCondition:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, projectKeys, projectValues, mkeys, mvalues, groupKeys, groupValues = conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + projectKeys[projectOldIndex] + '"', 1)
            CasesCondition = json.loads(CasesConditionStr)
        projectKeys.append('_id'), projectValues.append(0)
        projectKeys2.append('_id'), projectValues2.append(0)
        if isinstance(xVariableIDs, list):
            for variableItem in xVariableIDs:
                projectKeys.append(variableItem), projectValues.append(1)
                projectKeys2.append(variableItem), projectValues2.append(1)
                mkeys.append(variableItem)
                if variableItem in varMissingKey:
                    for missingKey, missingValue in varMissingValue[varMissingKey.index(variableItem)].items():
                        if missingKey == '$nin':
                            varMissingValue[varMissingKey.index(variableItem)][missingKey].extend(["", "None"])
                    mvalues.append(varMissingValue[varMissingKey.index(variableItem)])
                else:
                    mvalues.append({"$nin": ["", "None"]})
        else:
            projectKeys.append(xVariableIDs), projectValues.append(1)
            projectKeys2.append(xVariableIDs), projectValues2.append(1)
            mkeys.append(xVariableIDs)
            if xVariableIDs in varMissingKey:
                for missingKey, missingValue in varMissingValue[varMissingKey.index(xVariableIDs)].items():
                    if missingKey == '$nin':
                        varMissingValue[varMissingKey.index(xVariableIDs)][missingKey].extend(["", "None"])
                mvalues.append(varMissingValue[varMissingKey.index(xVariableIDs)])
            else:
                mvalues.append({"$nin": ["", "None"]})
        projectKeys.append(yVariableID), projectValues.append(1)
        projectKeys2.append(yVariableID), projectValues2.append(1)
        mkeys.append(yVariableID)
        if yVariableID in varMissingKey:
            for missingKey, missingValue in varMissingValue[varMissingKey.index(yVariableID)].items():
                if missingKey == '$nin':
                    varMissingValue[varMissingKey.index(yVariableID)][missingKey].extend(["", "None"])
            mvalues.append(varMissingValue[varMissingKey.index(yVariableID)])
        else:
            mvalues.append({"$nin": ["", "None"]})
        projects = json.dumps(dict(zip(projectKeys, projectValues)))
        matchs = json.dumps(dict(zip(mkeys, mvalues)))
        pipeline = [{"$match": json.loads(matchs)}]
        pipeline.append({"$project": json.loads(projects)})
        if CasesCondition:
            pipeline.append({"$match": CasesCondition})
            pipeline.append({"$project": dict(zip(projectKeys2, projectValues2))})
        # if varMissing:
        #     pipeline.append(varMissing["$match"])

        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId, dataVersion=version).aggregate(*pipeline)
        # else:

        dataSetIdSave = dataSetId
        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def close(self):
        self.res.disconnect()


# -----<相关分析>----- #
class mongoCorrelationAnalysisModel:
    def __init__(self, mongodb_cfg):  # libname="readInfo"
        self.libname = mongodb_cfg
        self.res = Pymongoengine(self.libname)

    def showDatas(self, dataSetId, version, yVariableIDs, CasesCondition, varMissingKey, varMissingValue):
        self.res.connect_db()
        projectKeys, projectValues, projectKeys2, projectValues2, mkeys, mvalues = [], [], [], [], [], []

        if CasesCondition:
            conditionGroup = []
            for keyCondition, valueCondition in CasesCondition.items():
                if keyCondition == '$and' or keyCondition == '$nor' or keyCondition == '$or':
                    for valueConditionItem in valueCondition:
                        if isinstance(valueConditionItem, dict):
                            if '$and' in valueConditionItem.keys() or '$nor' in valueConditionItem.keys() \
                                    or '$or' in valueConditionItem.keys():
                                for keyValueConditionItem, valueValueConditionItem in valueConditionItem.items():
                                    conditionGroup.append(valueValueConditionItem)
                            else:
                                conditionGroup.append(valueConditionItem)
                else:
                    conditionGroup.append({keyCondition: valueCondition})
            projectOld, projectKeys, projectValues, mkeys, mvalues, groupKeys, groupValues = conditionReset(conditionGroup)
            CasesConditionStr = json.dumps(CasesCondition, ensure_ascii=False)
            for projectOldIndex, projectOldItem in enumerate(projectOld):
                CasesConditionStr = CasesConditionStr.replace('"' + projectOldItem + '"',
                                                              '"' + projectKeys[projectOldIndex] + '"', 1)
            CasesCondition = json.loads(CasesConditionStr)
        projectKeys.append('_id'), projectValues.append(0)
        projectKeys2.append('_id'), projectValues2.append(0)
        if isinstance(yVariableIDs, list):
            for variableItem in yVariableIDs:
                projectKeys.append(variableItem), projectValues.append(1)
                projectKeys2.append(variableItem), projectValues2.append(1)
                mkeys.append(variableItem)
                if variableItem in varMissingKey:
                    for missingKey, missingValue in varMissingValue[varMissingKey.index(variableItem)].items():
                        if missingKey == '$nin':
                            varMissingValue[varMissingKey.index(variableItem)][missingKey].extend(["", "None"])
                    mvalues.append(varMissingValue[varMissingKey.index(variableItem)])
                else:
                    mvalues.append({"$nin": ["", "None"]})
        else:
            projectKeys.append(yVariableIDs), projectValues.append(1)
            projectKeys2.append(yVariableIDs), projectValues2.append(1)
            mkeys.append(yVariableIDs)
            if yVariableIDs in varMissingKey:
                for missingKey, missingValue in varMissingValue[varMissingKey.index(yVariableIDs)].items():
                    if missingKey == '$nin':
                        varMissingValue[varMissingKey.index(yVariableIDs)][missingKey].extend(["", "None"])
                mvalues.append(varMissingValue[varMissingKey.index(yVariableIDs)])
            else:
                mvalues.append({"$nin": ["", "None"]})
        matchs = json.dumps(dict(zip(mkeys, mvalues)))
        pipeline = [{"$match": json.loads(matchs)}]
        projects = json.dumps(dict(zip(projectKeys, projectValues)))
        pipeline.append({"$project": json.loads(projects)})
        if CasesCondition:
            pipeline.append({"$match": CasesCondition})
            pipeline.append({"$project": dict(zip(projectKeys2, projectValues2))})
        # if version and version is not None:
        #     ret = data_case.objects(dataSetId=dataSetId, dataVersion=version).aggregate(*pipeline)
        # else:
        dataSetIdSave = dataSetId

        class data_case_set(DynamicDocument):
            meta = {"collection": "data_case_" + dataSetIdSave}
            dataSetId = StringField(required=True, max_length=100)
            dataVersion = IntField(required=True)

        num_data_case = data_case_set.objects(dataSetId=dataSetId).count()
        if num_data_case > 0:
            dataSetFlag = True
            ret = data_case_set.objects(dataSetId=dataSetId).aggregate(*pipeline)
        else:
            dataSetFlag = False
            ret = data_case.objects(dataSetId=dataSetId).aggregate(*pipeline)
        return ret

    def close(self):
        self.res.disconnect()


def conditionReset(conditionGroup):
    projectOld, project, projectToNum, matchKeys, matchValues, groupKeys, groupValues, indexCondition, flagCondition = \
        [], [], [], [], [], [], [], 0, True
    while flagCondition:
        flagCondition = False
        for conditionGroupItem in conditionGroup:
            if isinstance(conditionGroupItem, list):
                flagCondition = True
                break
        if flagCondition: conditionGroup = conditionGroupReset(conditionGroup)
    for conditionGroupItem in conditionGroup:
        for keyCondition, valueCondition in conditionGroupItem.items():
            nowString = datetime.datetime.now().strftime('%H%M%S%f') + str(indexCondition)
            projectOld.append(keyCondition)
            project.append(keyCondition + copy.deepcopy(nowString))
            groupKeys.append(keyCondition + copy.deepcopy(nowString))
            if check_json_format(json.dumps(valueCondition)):
                for keyFilter, valueFilter in valueCondition.items():
                    if isinstance(valueFilter, bool):
                        projectToNum.append("$" + keyCondition)
                    elif isinstance(valueFilter, dict):
                        numberFlag = False
                        for valueFilterKey, valueFilterValue in valueFilter.items():
                            if not isinstance(valueFilterValue, bool) and (isinstance(valueFilterValue, int) or
                                                                           isinstance(valueFilterValue, float)):
                                numberFlag = True
                        if numberFlag:
                            matchKeys.append(keyCondition)
                            matchValues.append({"$nin": ["", "None"]})
                            projectToNum.append({"$toDouble": "$" + keyCondition})
                        else:
                            projectToNum.append("$" + keyCondition)
                    elif isinstance(valueFilter, int) or isinstance(valueFilter, float):
                        matchKeys.append(keyCondition)
                        matchValues.append({"$nin": ["", "None"]})
                        projectToNum.append({"$toDouble": "$" + keyCondition})
                    else:
                        projectToNum.append("$" + keyCondition)
                    break
            else:
                projectToNum.append("$" + keyCondition)
            groupValues.append({"$max": "$" + keyCondition})
            indexCondition += 1
    return projectOld, project, projectToNum, matchKeys, matchValues, groupKeys, groupValues


def conditionGroupReset(conditionGroup):
    flagCondition = True
    while flagCondition:
        flagCondition = False
        for conditionGroupItem in conditionGroup:
            if isinstance(conditionGroupItem, list):
                flagCondition = True
                break
        if flagCondition:
            for conditionGroupItem in conditionGroup:
                if isinstance(conditionGroupItem, list):
                    groupIndex = conditionGroup.index(conditionGroupItem)
                    conditionGroup.remove(conditionGroupItem)
                    for conditionGroupItemIndex, conditionGroupItemValue in enumerate(conditionGroupItem):
                            groupIndex += conditionGroupItemIndex
                            conditionGroup.insert(groupIndex, conditionGroupItemValue)
    flagCondition = True
    while flagCondition:
        flagCondition = False
        for conditionGroupItem in conditionGroup:
            if not isinstance(conditionGroupItem, list) and (json.dumps(conditionGroupItem).find('$and') > -1 or
                                                             json.dumps(conditionGroupItem).find('$nor') > -1 or
                                                             json.dumps(conditionGroupItem).find('$or') > -1):
                flagCondition = True
                groupIndex = conditionGroup.index(conditionGroupItem)
                conditionGroup.remove(conditionGroupItem)
                for keyValueConditionItem, valueValueConditionItem in conditionGroupItem.items():
                    conditionGroup.insert(groupIndex, valueValueConditionItem)
    return conditionGroup


def check_json_format(raw_msg):
    if isinstance(raw_msg, str):
        try:
            json.loads(raw_msg)
            for key, value in json.loads(str(raw_msg).strip()).items():
                return True
        except Exception as e:
            pass
        return False
    else:
        return False
