# -*- coding:utf-8 -*-

import tornado.ioloop
import tornado.web
import tornado.httpserver
# import logging
from common.myLog.MyProjectLog  import *
from tornado.options import define, options
from Handler import *
import configparser

define("conf", default='analy.cnf', help='tornado settings file', type=str)

def tornado_start():
    print('===')
    nacos_main(nacosConf)
    static_path = os.path.join(os.path.dirname(__file__), "static")
    application=tornado.web.Application(
        [(r"/", IndexHandler),
         (r"/stata_down/(.*)", tornado.web.StaticFileHandler, {'path':'stata_down'}),#dict(basepath="/stata_down/")
         (r"/statafile", statafile_Handler),#(r"/stata_input", stata_input_Handler),
         (r"/means", means_Handler), (r"/compareMeans", compareMeans_Handler),
         (r"/means2", means2_Handler), (r"/compareMeans2", compareMeans2_Handler),
         (r"/frequency", frequency_Handler),
         (r"/multipleResponse", multipleResponse_Handler), (r"/multiple2Response", multiple2Response_Handler),
         (r"/multipleTypeResponse", multipleTypeResponse_Handler),
         (r"/crosstabsMultipleResponse", crosstabsMultipleResponse_Handler),
         (r"/crosstabsMultiple2Response", crosstabsMultiple2Response_Handler),
         (r"/crosstabsMultipleTypeResponse", crosstabsMultipleTypeResponse_Handler),
         (r"/multipleAndMultipleCrossResponse", multipleAndMultipleCrossResponse_Handler),
         (r"/multipleAndSingleCrossResponse", multipleAndSingleCrossResponse_Handler),
         (r"/crosstabs", crosstabs_Handler), (r"/linearRegression", linearRegression_Handler),
         (r"/Ttest_indResult", Ttest_indResult_Handler), (r"/Ttest_SingleSample", Ttest_SingleSample_Handler),
         (r"/Ttest_PairedSamples", Ttest_PairedSamples_Handler),
         (r"/correlationAnalysis", correlationAnalysis_Handler),
         (r"/wordFrequency", wordFrequency_Handler), (r"/sort", sort_Handler),
         (r"/twoDimensionalLogisticRegression", twoDimensionalLogisticRegression_Handler),
         (r"/normalityDistribution", normalityDistribution_Handler),
         (r"/LDAModel", wordLDAModel_Handler),
         (r"/kmeansModel", wordKmeansModel_Handler),
         (r"/sentimentModel", wordSentimentModel_Handler),
         (r"/semanticNetworkModel", wordSemanticNetworkModel_Handler),
         (r"/socialNetworkModel", wordSocialNetworkModel_Handler),
         # (r"/correlationAnalysis", correlationAnalysis_Handler),
        ],static_path )

    http_server=tornado.httpserver.HTTPServer(application)
    # log=logger.()
    tornado.options.parse_command_line()
    http_server.bind(options.port)
    http_server.start(10)
    # application.listen(options.port)
    tornado.ioloop.IOLoop.instance().start()


class config(object):
    """
    # Config().get_content("user_information")
    """
    def __init__(self):
        if os.path.abspath(os.curdir).find('zkey_analy') > -1:
            file_path = os.path.join(os.path.abspath(os.curdir), "conf", BaseConf.BaseCnf)
        else:
            file_path = os.path.join(os.path.abspath(os.curdir), "zkey_analy", "conf", BaseConf.BaseCnf)

        self.cf = configparser.ConfigParser()
        self.cf.read(file_path,encoding='utf-8')
    def get_sections(self):
        return self.cf.sections()

    def get_options(self, section):
        return self.cf.options(section)

    def get_content(self, section):
        result = {}
        for option in self.get_options(section):
            value = self.cf.get(section, option)
            result[option] = int(value) if value.isdigit() else value
        return result

serverPort = config().get_content("server")
nacosConf = config().get_content("nacos")

define("port", default=serverPort['serverport'], help="run on the given port", type=int)
#testFlag = True

if __name__=="__main__":
    tornado_start()

