#!/usr/bin/env python
# -*- coding:utf-8 -*-


CODEMSG = {
    2000: "True",
    4000: "客户上传的文件格式不正确",
    4001: "客户上传的文件列超过1024",
    4002: "客户端未传值!",
    4003: "文件数据格式不对",
    4004: "",
    4005: "用户未认证或认证不成功",
    4006: "无法进行数据分析",
    4007: "用户分析条件不正确",
    4008: "用户无权限",
    4009: "值传递错误!!!",
    4010: "调用权限接口返回不允许状态",
    4011: "长度不一致（LENGTH ERROR！！！）",
    4012: "无数据导致错误（NOT DATA ERROR！！！）",
    4013: "无文件导致错误（NOT FILE ERROR！！！）",
    4014: "秘钥解密失败",
    4015: "因变量应为二分数值",
    4022: "分组变量应为二分数值",
    4016: "请等待管理员发送",
    4017: "下载申请已提交请等待审核",
    4018: "线上审核后线上下载",
    4019: "线上审核后邮件发送",
    4020: "仅供分析探索不提供原始数据",
    4021: "权限错误",
    4023: "有重复变量，请修改后再次上传！！！",
    4024: "请更改变量名， 此变量名‘mycustomid’为系统关键字",
    4025: "收藏夹内无变量",
    4026: "无法分割字符",
    4027: "",
    4999: "Unknown Error!!!",
    5000: "服务器错误",
    5001: "数据表已经存在",
    5002: "SQL语句错误",
    5003: "索引文件未创建"
}


class MyCustomError(Exception):
    """
    Error class for the IBM SPSS Statistics Input Output Module
    Use Method:

    def example():
        try:
            raise ValueError # ['']
            raise SPSSError(retcode="6001") or  raise SPSSError(retcode=6001)
        except Exception as e:
            e = FormatErrorCode(e)
            print(e) # ['4999', 'Unknown Error!!!']

    example()

    #>>> (5001, '数据表已经存在')

    """

    def __init__(self, msg=None, retcode=4999):
        self.retcode = int(retcode)
        try:
            if not msg:
                msg = CODEMSG[int(self.retcode)]
        except:
            msg = "Unknown Error!!!"
        Exception.__init__(self, self.retcode, msg)


def FormatErrorCode(arg):
    # print(arg)
    data = str(arg).replace("(", "").replace(")", "").replace("'", '').replace('"', '').split(",")
    # print(data)
    if all(data):
        Error_Infor = [i.strip() for i in data if i]
        if len(Error_Infor) == 2:
            if data[0] == '1264' or "list index out of range" in data[1]:
                return ['4027', data[1]]
            else:
                return [i.strip() for i in data if i]
        else:
            try:
                if str(arg) == "list index out of range":
                    raise MyCustomError(retcode=4009)
                else:
                    raise MyCustomError(msg=Error_Infor[0])
            except Exception as e:
                return FormatErrorCode(e)
    else:
        try:
            raise MyCustomError()
        except Exception as e:
            return FormatErrorCode(e)


class SPSSError(MyCustomError):
    def __init__(self, retcode=None):
        super(SPSSError, self).__init__(retcode=retcode)


class GetParametersError(MyCustomError):
    def __init__(self, retcode=4002):
        super(GetParametersError, self).__init__(retcode=retcode)


class LoginInError(MyCustomError):
    def __init__(self, retcode=4005):
        super(LoginInError, self).__init__(retcode=retcode)

class PermissionNotError(MyCustomError):
    def __init__(self, retcode=4008):
        super(PermissionNotError, self).__init__(retcode=retcode)

# ----<值传递错误， 针对前端传值使用>-----#
class ValuePropagetionError(MyCustomError):
    def __init__(self, retcode=4009):
        super(ValuePropagetionError, self).__init__(retcode=retcode)

